/* This file is automatically generated by Lemon from input grammar
** source file "parser.y". */
/*
** 2000-05-29
**
** The author disclaims copyright to this source code.  In place of
** a legal notice, here is a blessing:
**
**    May you do good and not evil.
**    May you find forgiveness for yourself and forgive others.
**    May you share freely, never taking more than you give.
**
*************************************************************************
** Driver template for the LEMON parser generator.
**
** The "lemon" program processes an LALR(1) input grammar file, then uses
** this template to construct a parser.  The "lemon" program inserts text
** at each "%%" line.  Also, any "P-a-r-s-e" identifer prefix (without the
** interstitial "-" characters) contained in this template is changed into
** the value of the %name directive from the grammar.  Otherwise, the content
** of this template is copied straight through into the generate parser
** source file.
**
** The following is the concatenation of all %include directives from the
** input grammar file:
*/
/************ Begin %include sections from the grammar ************************/
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <assert.h>

#include "../parse.h"

// unescape a string (non null terminated) and return the new length (may be shorter than the original. This manipulates the string itself
static size_t unescapen(char *s, size_t sz) {

  char *dst = s;
  char *src = dst;
  char *end = s + sz;
  while (src < end) {
      // unescape
      if (*src == '\\' && src + 1 < end &&
         (ispunct(*(src+1)) || isspace(*(src+1)))) {
          ++src;
          continue;
      }
      *dst++ = *src++;
  }

  return (size_t)(dst - s);
}

#define NODENN_BOTH_VALID 0
#define NODENN_BOTH_INVALID -1
#define NODENN_ONE_NULL 1
// Returns:
// 0 if a && b
// -1 if !a && !b
// 1 if a ^ b (i.e. !(a&&b||!a||!b)). The result is stored in `out`
static int one_not_null(void *a, void *b, void *out) {
    if (a && b) {
        return NODENN_BOTH_VALID;
    } else if (a == NULL && b == NULL) {
        return NODENN_BOTH_INVALID;
    } if (a) {
        *(void **)out = a;
        return NODENN_ONE_NULL;
    } else {
        *(void **)out = b;
        return NODENN_ONE_NULL;
    }
}

static void setup_trace(QueryParseCtx *ctx) {
#ifdef PARSER_DEBUG
  void RSQueryParser_Trace(FILE*, char*);
  ctx->trace_log = fopen("/tmp/lemon_query.log", "w");
  RSQueryParser_Trace(ctx->trace_log, "tr: ");
#endif
}

static void reportSyntaxError(QueryError *status, QueryToken* tok, const char *msg) {
  if (tok->type == QT_TERM || tok->type == QT_TERM_CASE) {
    QueryError_SetErrorFmt(status, QUERY_ESYNTAX,
      "%s at offset %d near %.*s", msg, tok->pos, tok->len, tok->s);
  } else if (tok->type == QT_NUMERIC) {
    QueryError_SetErrorFmt(status, QUERY_ESYNTAX,
      "%s at offset %d near %f", msg, tok->pos, tok->numval);
  } else {
    QueryError_SetErrorFmt(status, QUERY_ESYNTAX, "%s at offset %d", msg, tok->pos);
  }
}

/**************** End of %include directives **********************************/
/* These constants specify the various numeric values for terminal symbols.
***************** Begin token definitions *************************************/
#ifndef LOWEST
#define LOWEST                          1
#define TEXTEXPR                        2
#define ORX                             3
#define OR                              4
#define MODIFIER                        5
#define RP                              6
#define RB                              7
#define RSQB                            8
#define TERM                            9
#define QUOTE                          10
#define LP                             11
#define LB                             12
#define LSQB                           13
#define TILDE                          14
#define MINUS                          15
#define AND                            16
#define ARROW                          17
#define COLON                          18
#define NUMBER                         19
#define SIZE                           20
#define STOPWORD                       21
#define STAR                           22
#define TAGLIST                        23
#define TERMLIST                       24
#define PREFIX                         25
#define PERCENT                        26
#define ATTRIBUTE                      27
#define AS_S                           28
#define AS_T                           29
#define SEMICOLON                      30
#endif
/**************** End token definitions ***************************************/

/* The next sections is a series of control #defines.
** various aspects of the generated parser.
**    YYCODETYPE         is the data type used to store the integer codes
**                       that represent terminal and non-terminal symbols.
**                       "unsigned char" is used if there are fewer than
**                       256 symbols.  Larger types otherwise.
**    YYNOCODE           is a number of type YYCODETYPE that is not used for
**                       any terminal or nonterminal symbol.
**    YYFALLBACK         If defined, this indicates that one or more tokens
**                       (also known as: "terminal symbols") have fall-back
**                       values which should be used if the original symbol
**                       would not parse.  This permits keywords to sometimes
**                       be used as identifiers, for example.
**    YYACTIONTYPE       is the data type used for "action codes" - numbers
**                       that indicate what to do in response to the next
**                       token.
**    RSQueryParser_v2_TOKENTYPE     is the data type used for minor type for terminal
**                       symbols.  Background: A "minor type" is a semantic
**                       value associated with a terminal or non-terminal
**                       symbols.  For example, for an "ID" terminal symbol,
**                       the minor type might be the name of the identifier.
**                       Each non-terminal can have a different minor type.
**                       Terminal symbols all have the same minor type, though.
**                       This macros defines the minor type for terminal 
**                       symbols.
**    YYMINORTYPE        is the data type used for all minor types.
**                       This is typically a union of many types, one of
**                       which is RSQueryParser_v2_TOKENTYPE.  The entry in the union
**                       for terminal symbols is called "yy0".
**    YYSTACKDEPTH       is the maximum depth of the parser's stack.  If
**                       zero the stack is dynamically sized using realloc()
**    RSQueryParser_v2_ARG_SDECL     A static variable declaration for the %extra_argument
**    RSQueryParser_v2_ARG_PDECL     A parameter declaration for the %extra_argument
**    RSQueryParser_v2_ARG_PARAM     Code to pass %extra_argument as a subroutine parameter
**    RSQueryParser_v2_ARG_STORE     Code to store %extra_argument into yypParser
**    RSQueryParser_v2_ARG_FETCH     Code to extract %extra_argument from yypParser
**    RSQueryParser_v2_CTX_*         As RSQueryParser_v2_ARG_ except for %extra_context
**    YYERRORSYMBOL      is the code number of the error symbol.  If not
**                       defined, then do no error processing.
**    YYNSTATE           the combined number of states.
**    YYNRULE            the number of rules in the grammar
**    YYNTOKEN           Number of terminal symbols
**    YY_MAX_SHIFT       Maximum value for shift actions
**    YY_MIN_SHIFTREDUCE Minimum value for shift-reduce actions
**    YY_MAX_SHIFTREDUCE Maximum value for shift-reduce actions
**    YY_ERROR_ACTION    The yy_action[] code for syntax error
**    YY_ACCEPT_ACTION   The yy_action[] code for accept
**    YY_NO_ACTION       The yy_action[] code for no-op
**    YY_MIN_REDUCE      Minimum value for reduce actions
**    YY_MAX_REDUCE      Maximum value for reduce actions
*/
#ifndef INTERFACE
# define INTERFACE 1
#endif
/************* Begin control #defines *****************************************/
#define YYCODETYPE unsigned char
#define YYNOCODE 58
#define YYACTIONTYPE unsigned short int
#define RSQueryParser_v2_TOKENTYPE QueryToken
typedef union {
  int yyinit;
  RSQueryParser_v2_TOKENTYPE yy0;
  SingleVectorQueryParam yy9;
  QueryAttribute * yy17;
  QueryParam * yy22;
  QueryAttribute yy59;
  RangeNumber yy79;
  VectorQueryParams yy102;
  Vector* yy103;
  QueryNode * yy111;
} YYMINORTYPE;
#ifndef YYSTACKDEPTH
#define YYSTACKDEPTH 256
#endif
#define RSQueryParser_v2_ARG_SDECL  QueryParseCtx *ctx ;
#define RSQueryParser_v2_ARG_PDECL , QueryParseCtx *ctx 
#define RSQueryParser_v2_ARG_PARAM ,ctx 
#define RSQueryParser_v2_ARG_FETCH  QueryParseCtx *ctx =yypParser->ctx ;
#define RSQueryParser_v2_ARG_STORE yypParser->ctx =ctx ;
#define RSQueryParser_v2_CTX_SDECL
#define RSQueryParser_v2_CTX_PDECL
#define RSQueryParser_v2_CTX_PARAM
#define RSQueryParser_v2_CTX_FETCH
#define RSQueryParser_v2_CTX_STORE
#define YYFALLBACK 1
#define YYNSTATE             115
#define YYNRULE              97
#define YYNRULE_WITH_ACTION  93
#define YYNTOKEN             31
#define YY_MAX_SHIFT         114
#define YY_MIN_SHIFTREDUCE   179
#define YY_MAX_SHIFTREDUCE   275
#define YY_ERROR_ACTION      276
#define YY_ACCEPT_ACTION     277
#define YY_NO_ACTION         278
#define YY_MIN_REDUCE        279
#define YY_MAX_REDUCE        375
/************* End control #defines *******************************************/
#define YY_NLOOKAHEAD ((int)(sizeof(yy_lookahead)/sizeof(yy_lookahead[0])))

/* Define the yytestcase() macro to be a no-op if is not already defined
** otherwise.
**
** Applications can choose to define yytestcase() in the %include section
** to a macro that can assist in verifying code coverage.  For production
** code the yytestcase() macro should be turned off.  But it is useful
** for testing.
*/
#ifndef yytestcase
# define yytestcase(X)
#endif


/* Next are the tables used to determine what action to take based on the
** current state and lookahead token.  These tables are used to implement
** functions that take a state number and lookahead value and return an
** action integer.  
**
** Suppose the action integer is N.  Then the action is determined as
** follows
**
**   0 <= N <= YY_MAX_SHIFT             Shift N.  That is, push the lookahead
**                                      token onto the stack and goto state N.
**
**   N between YY_MIN_SHIFTREDUCE       Shift to an arbitrary state then
**     and YY_MAX_SHIFTREDUCE           reduce by rule N-YY_MIN_SHIFTREDUCE.
**
**   N == YY_ERROR_ACTION               A syntax error has occurred.
**
**   N == YY_ACCEPT_ACTION              The parser accepts its input.
**
**   N == YY_NO_ACTION                  No such action.  Denotes unused
**                                      slots in the yy_action[] table.
**
**   N between YY_MIN_REDUCE            Reduce by rule N-YY_MIN_REDUCE
**     and YY_MAX_REDUCE
**
** The action table is constructed as a single large table named yy_action[].
** Given state S and lookahead X, the action is computed as either:
**
**    (A)   N = yy_action[ yy_shift_ofst[S] + X ]
**    (B)   N = yy_default[S]
**
** The (A) formula is preferred.  The B formula is used instead if
** yy_lookahead[yy_shift_ofst[S]+X] is not equal to X.
**
** The formulas above are for computing the action when the lookahead is
** a terminal symbol.  If the lookahead is a non-terminal (as occurs after
** a reduce action) then the yy_reduce_ofst[] array is used in place of
** the yy_shift_ofst[] array.
**
** The following are the tables generated in this section:
**
**  yy_action[]        A single table containing all actions.
**  yy_lookahead[]     A table containing the lookahead for each entry in
**                     yy_action.  Used to detect hash collisions.
**  yy_shift_ofst[]    For each state, the offset into yy_action for
**                     shifting terminals.
**  yy_reduce_ofst[]   For each state, the offset into yy_action for
**                     shifting non-terminals after a reduce.
**  yy_default[]       Default action for each state.
**
*********** Begin parsing tables **********************************************/
#define YY_ACTTAB_COUNT (693)
static const YYACTIONTYPE yy_action[] = {
 /*     0 */   371,  354,   45,  104,   12,  226,  197,   47,  105,  262,
 /*    10 */    44,   15,  346,   58,   13,   14,   57,   92,  313,  263,
 /*    20 */   264,  211,  371,  300,   78,  219,   56,  265,  111,   93,
 /*    30 */    16,  226,  198,   68,  110,  262,   44,   15,   84,   42,
 /*    40 */    13,   14,   63,  112,   72,  263,  264,  211,  328,  332,
 /*    50 */    61,  219,   56,  265,  279,   80,   87,   42,   12,  226,
 /*    60 */   349,  275,  274,  262,   44,   15,  353,   67,   13,   14,
 /*    70 */   357,   77,  102,  263,  264,  211,  352,  345,   58,  219,
 /*    80 */    56,  265,  280,   91,   42,  358,   65,  226,  300,   82,
 /*    90 */    64,  262,   44,    1,  256,  255,   13,   14,  336,   60,
 /*   100 */   259,  263,  264,  211,  272,   54,   50,  219,   56,  265,
 /*   110 */   260,  261,   16,  226,  371,  281,   66,  262,   44,   15,
 /*   120 */   312,   46,   13,   14,  266,   75,  299,  263,  264,  211,
 /*   130 */   371,  267,   88,  219,   56,  265,   70,   48,   12,  226,
 /*   140 */    53,   52,   71,  262,   44,   15,   73,  327,   13,   14,
 /*   150 */    30,   92,  226,  263,  264,  211,   26,   89,  301,  219,
 /*   160 */    56,  265,  343,   83,   16,  226,   86,   51,  204,  262,
 /*   170 */    44,   15,  273,   43,   13,   14,  229,  112,  344,  263,
 /*   180 */   264,  211,  342,  251,   90,  219,   56,  265,  241,   53,
 /*   190 */    34,   74,  198,  223,  224,  262,   44,   33,   95,  225,
 /*   200 */    31,   32,  278,  112,   35,  263,  264,  211,  361,   97,
 /*   210 */    98,  219,   56,  265,  222,  100,  101,  226,  221,  103,
 /*   220 */   220,  262,   44,    1,  360,  310,   13,   14,  113,   38,
 /*   230 */   205,  263,  264,  211,  272,  359,  208,  219,   56,  265,
 /*   240 */   226,  207,   69,  309,  262,   44,   15,   17,   54,   13,
 /*   250 */    14,  278,   92,   74,  263,  264,  211,  263,  264,  211,
 /*   260 */   219,   56,  265,  219,   56,  265,  226,  278,  278,  278,
 /*   270 */   262,   44,   15,  278,  278,   13,   14,  278,  112,  278,
 /*   280 */   263,  264,  211,  278,  278,  278,  219,   56,  265,  278,
 /*   290 */   262,   44,   33,   40,   49,   31,   32,  278,  278,  278,
 /*   300 */   263,  264,  211,  278,  278,   34,  219,   56,  265,  278,
 /*   310 */   262,   44,   33,  278,  278,   31,   32,  278,  112,  278,
 /*   320 */   263,  264,  211,  278,  278,  278,  219,   56,  265,  278,
 /*   330 */   278,  310,  226,  278,  113,   39,  262,   44,   15,  278,
 /*   340 */   278,   13,   14,  278,  278,  278,  263,  264,  211,  309,
 /*   350 */   278,  278,  219,   56,  265,  278,  262,   44,   33,  278,
 /*   360 */   278,   31,   32,  278,  112,  278,  263,  264,  211,  278,
 /*   370 */   278,  278,  219,   56,  265,  278,  262,   44,   33,  278,
 /*   380 */   278,   31,   32,  278,  278,  278,  263,  264,  211,  278,
 /*   390 */   278,  278,  219,   56,  265,  278,    4,  278,  278,  310,
 /*   400 */   278,  114,  113,    5,   65,  278,  278,  278,   64,  278,
 /*   410 */   278,   79,  256,  255,  277,   76,   81,  309,    2,  278,
 /*   420 */   269,  310,  278,  114,  113,    3,  278,  278,  278,  278,
 /*   430 */   278,  278,   92,   79,  263,  264,  211,   85,   81,  309,
 /*   440 */   219,   56,  265,   22,  278,  278,  310,  278,  114,  113,
 /*   450 */    25,  278,  112,  278,  263,  264,  211,  278,   79,  278,
 /*   460 */   219,   56,  265,   81,  309,   23,  278,  278,  310,  278,
 /*   470 */   114,  113,   24,  278,  310,  278,  278,  113,   41,  278,
 /*   480 */    79,  340,  278,  278,  278,   81,  309,  278,  338,  278,
 /*   490 */     9,  262,  309,  310,  278,  114,  113,   10,  278,  278,
 /*   500 */   278,  263,  264,  231,  278,   79,  278,  219,  278,  265,
 /*   510 */    81,  309,   19,  262,  278,  310,  278,  114,  113,   20,
 /*   520 */   278,  278,  278,  263,  264,  235,  278,   79,  270,  219,
 /*   530 */    59,  265,   81,  309,   64,  278,  278,   18,  256,  255,
 /*   540 */   310,  278,  114,  113,   21,  310,  268,  278,  113,   36,
 /*   550 */   310,  278,   79,  113,   37,  278,  278,   81,  309,    2,
 /*   560 */   278,  278,  310,  309,  114,  113,    3,  310,  309,  278,
 /*   570 */   113,   27,  278,  278,   79,  278,  278,  278,  310,   81,
 /*   580 */   309,  113,   29,  278,    8,  309,  278,  310,  278,  114,
 /*   590 */   113,   11,  108,  278,  278,  278,  309,  310,  278,   79,
 /*   600 */   113,   28,  107,  106,   81,  309,    6,  278,  278,  310,
 /*   610 */   109,  114,  113,    7,  278,  309,  278,  278,  278,  278,
 /*   620 */   262,   79,  239,  270,  278,   59,   81,  309,  278,   64,
 /*   630 */   263,  264,  262,  256,  255,  262,  278,  278,  265,  278,
 /*   640 */   278,  268,  263,  264,   96,  263,  264,   94,  278,   62,
 /*   650 */   265,  262,   55,  265,  262,  206,  278,  278,  278,  278,
 /*   660 */   278,  263,  264,  250,  263,  264,  214,  278,  278,  265,
 /*   670 */   278,  262,  265,  278,  262,  278,  278,  278,  278,  278,
 /*   680 */   278,  263,  264,  214,  263,  264,   99,  278,  278,  265,
 /*   690 */   278,  278,  265,
};
static const YYCODETYPE yy_lookahead[] = {
 /*     0 */    47,   44,   45,   52,    4,    5,    6,   54,   52,    9,
 /*    10 */    10,   11,   55,   56,   14,   15,   35,   17,   52,   19,
 /*    20 */    20,   21,   47,   32,   33,   25,   26,   27,   27,   54,
 /*    30 */     4,    5,    6,   52,   53,    9,   10,   11,   42,   43,
 /*    40 */    14,   15,    9,   17,    9,   19,   20,   21,   53,   34,
 /*    50 */    35,   25,   26,   27,    0,   40,   42,   43,    4,    5,
 /*    60 */    52,   28,   29,    9,   10,   11,   44,   52,   14,   15,
 /*    70 */    47,   17,   52,   19,   20,   21,   52,   55,   56,   25,
 /*    80 */    26,   27,    0,   42,   43,   47,   11,    5,   32,   33,
 /*    90 */    15,    9,   10,   11,   19,   20,   14,   15,   34,   35,
 /*   100 */     9,   19,   20,   21,   22,   12,   13,   25,   26,   27,
 /*   110 */    19,   20,    4,    5,   47,    0,   52,    9,   10,   11,
 /*   120 */    52,   54,   14,   15,   20,   17,   52,   19,   20,   21,
 /*   130 */    47,   27,   17,   25,   26,   27,    4,   54,    4,    5,
 /*   140 */    12,   13,    4,    9,   10,   11,   57,   53,   14,   15,
 /*   150 */    18,   17,    5,   19,   20,   21,   18,   51,   32,   25,
 /*   160 */    26,   27,    0,    8,    4,    5,    8,   13,    7,    9,
 /*   170 */    10,   11,    6,    4,   14,   15,    7,   17,    0,   19,
 /*   180 */    20,   21,    0,   27,    8,   25,   26,   27,    8,   12,
 /*   190 */     4,   30,    6,   26,   26,    9,   10,   11,   26,   26,
 /*   200 */    14,   15,   58,   17,    4,   19,   20,   21,   10,   26,
 /*   210 */    26,   25,   26,   27,   26,   26,   26,    5,   26,   26,
 /*   220 */    26,    9,   10,   11,   10,   34,   14,   15,   37,   38,
 /*   230 */     7,   19,   20,   21,   22,   10,   10,   25,   26,   27,
 /*   240 */     5,   10,   18,   52,    9,   10,   11,    4,   12,   14,
 /*   250 */    15,   58,   17,   30,   19,   20,   21,   19,   20,   21,
 /*   260 */    25,   26,   27,   25,   26,   27,    5,   58,   58,   58,
 /*   270 */     9,   10,   11,   58,   58,   14,   15,   58,   17,   58,
 /*   280 */    19,   20,   21,   58,   58,   58,   25,   26,   27,   58,
 /*   290 */     9,   10,   11,   12,   13,   14,   15,   58,   58,   58,
 /*   300 */    19,   20,   21,   58,   58,    4,   25,   26,   27,   58,
 /*   310 */     9,   10,   11,   58,   58,   14,   15,   58,   17,   58,
 /*   320 */    19,   20,   21,   58,   58,   58,   25,   26,   27,   58,
 /*   330 */    58,   34,    5,   58,   37,   38,    9,   10,   11,   58,
 /*   340 */    58,   14,   15,   58,   58,   58,   19,   20,   21,   52,
 /*   350 */    58,   58,   25,   26,   27,   58,    9,   10,   11,   58,
 /*   360 */    58,   14,   15,   58,   17,   58,   19,   20,   21,   58,
 /*   370 */    58,   58,   25,   26,   27,   58,    9,   10,   11,   58,
 /*   380 */    58,   14,   15,   58,   58,   58,   19,   20,   21,   58,
 /*   390 */    58,   58,   25,   26,   27,   58,   31,   58,   58,   34,
 /*   400 */    58,   36,   37,   38,   11,   58,   58,   58,   15,   58,
 /*   410 */    58,   46,   19,   20,   49,   50,   51,   52,   31,   58,
 /*   420 */    27,   34,   58,   36,   37,   38,   58,   58,   58,   58,
 /*   430 */    58,   58,   17,   46,   19,   20,   21,   50,   51,   52,
 /*   440 */    25,   26,   27,   31,   58,   58,   34,   58,   36,   37,
 /*   450 */    38,   58,   17,   58,   19,   20,   21,   58,   46,   58,
 /*   460 */    25,   26,   27,   51,   52,   31,   58,   58,   34,   58,
 /*   470 */    36,   37,   38,   58,   34,   58,   58,   37,   38,   58,
 /*   480 */    46,   41,   58,   58,   58,   51,   52,   58,   48,   58,
 /*   490 */    31,    9,   52,   34,   58,   36,   37,   38,   58,   58,
 /*   500 */    58,   19,   20,   21,   58,   46,   58,   25,   58,   27,
 /*   510 */    51,   52,   31,    9,   58,   34,   58,   36,   37,   38,
 /*   520 */    58,   58,   58,   19,   20,   21,   58,   46,    9,   25,
 /*   530 */    11,   27,   51,   52,   15,   58,   58,   31,   19,   20,
 /*   540 */    34,   58,   36,   37,   38,   34,   27,   58,   37,   38,
 /*   550 */    34,   58,   46,   37,   38,   58,   58,   51,   52,   31,
 /*   560 */    58,   58,   34,   52,   36,   37,   38,   34,   52,   58,
 /*   570 */    37,   38,   58,   58,   46,   58,   58,   58,   34,   51,
 /*   580 */    52,   37,   38,   58,   31,   52,   58,   34,   58,   36,
 /*   590 */    37,   38,    9,   58,   58,   58,   52,   34,   58,   46,
 /*   600 */    37,   38,   19,   20,   51,   52,   31,   58,   58,   34,
 /*   610 */    27,   36,   37,   38,   58,   52,   58,   58,   58,   58,
 /*   620 */     9,   46,    8,    9,   58,   11,   51,   52,   58,   15,
 /*   630 */    19,   20,    9,   19,   20,    9,   58,   58,   27,   58,
 /*   640 */    58,   27,   19,   20,   21,   19,   20,   21,   58,   26,
 /*   650 */    27,    9,   26,   27,    9,   10,   58,   58,   58,   58,
 /*   660 */    58,   19,   20,   21,   19,   20,   21,   58,   58,   27,
 /*   670 */    58,    9,   27,   58,    9,   58,   58,   58,   58,   58,
 /*   680 */    58,   19,   20,   21,   19,   20,   21,   58,   58,   27,
 /*   690 */    58,   58,   27,   58,   58,   58,   58,   58,   58,   58,
 /*   700 */    58,   58,   58,   58,   58,   58,   31,   31,   31,   31,
 /*   710 */    31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
 /*   720 */    31,   31,   31,   31,
};
#define YY_SHIFT_COUNT    (114)
#define YY_SHIFT_MIN      (0)
#define YY_SHIFT_MAX      (665)
static const unsigned short int yy_shift_ofst[] = {
 /*     0 */    82,  212,    0,   26,   54,  108,  134,  160,  235,  235,
 /*    10 */   261,  261,  327,  327,  327,  327,  327,  327,  415,  415,
 /*    20 */   435,  435,  415,  415,  435,  435,  281,  186,  301,  347,
 /*    30 */   367,  367,  367,  367,  367,  367,  435,  435,  435,  238,
 /*    40 */   482,  238,   33,  504,  583,   33,  614,  519,  519,  519,
 /*    50 */    35,   35,   35,    1,    1,  623,  626,  645,  642,  393,
 /*    60 */   662,  662,  665,  611,   75,   75,  611,  611,  611,  611,
 /*    70 */    91,   91,  104,  147,    1,   93,  115,  128,  161,  132,
 /*    80 */   169,  138,  223,  162,  155,  166,  178,  158,  154,  156,
 /*    90 */   182,  176,  177,  180,  167,  168,  172,  173,  183,  184,
 /*   100 */   188,  189,  190,  192,  193,  194,  198,  214,  225,  226,
 /*   110 */   231,  224,  236,  200,  243,
};
#define YY_REDUCE_COUNT (74)
#define YY_REDUCE_MIN   (-49)
#define YY_REDUCE_MAX   (575)
static const short yy_reduce_ofst[] = {
 /*     0 */   365,  387,  412,  434,  412,  434,  412,  434,  412,  412,
 /*    10 */   434,  434,  459,  481,  506,  528,  553,  575,  412,  412,
 /*    20 */   434,  434,  412,  412,  434,  434,  440,  191,  191,  191,
 /*    30 */   297,  511,  516,  533,  544,  563,  191,  191,  191,  191,
 /*    40 */    15,  191,  -43,   64,  -19,   22,  -47,  -25,   67,   83,
 /*    50 */    -4,   14,   41,   -9,   56,  -49,  -44,  -34,    8,   23,
 /*    60 */   -34,  -34,   20,   24,   38,   23,   68,   68,   68,   74,
 /*    70 */    -5,   94,   89,  106,  126,
};
static const YYACTIONTYPE yy_default[] = {
 /*     0 */   276,  276,  276,  276,  276,  282,  289,  282,  290,  288,
 /*    10 */   291,  293,  276,  276,  276,  276,  276,  276,  315,  317,
 /*    20 */   318,  316,  283,  284,  286,  285,  276,  276,  294,  293,
 /*    30 */   276,  276,  276,  276,  276,  276,  318,  316,  286,  296,
 /*    40 */   276,  295,  348,  276,  276,  347,  276,  276,  276,  276,
 /*    50 */   276,  276,  276,  303,  303,  276,  276,  276,  276,  276,
 /*    60 */   337,  333,  276,  276,  276,  276,  334,  330,  276,  276,
 /*    70 */   276,  276,  276,  276,  302,  276,  276,  276,  276,  276,
 /*    80 */   276,  276,  276,  276,  276,  276,  276,  276,  276,  276,
 /*    90 */   276,  276,  276,  276,  276,  276,  276,  276,  276,  276,
 /*   100 */   276,  276,  276,  276,  276,  276,  364,  363,  362,  365,
 /*   110 */   276,  276,  276,  292,  287,
};
/********** End of lemon-generated parsing tables *****************************/

/* The next table maps tokens (terminal symbols) into fallback tokens.  
** If a construct like the following:
** 
**      %fallback ID X Y Z.
**
** appears in the grammar, then ID becomes a fallback token for X, Y,
** and Z.  Whenever one of the tokens X, Y, or Z is input to the parser
** but it does not parse, the type of the token is changed to ID and
** the parse is retried before an error is thrown.
**
** This feature can be used, for example, to cause some keywords in a language
** to revert to identifiers if they keyword does not apply in the context where
** it appears.
*/
#ifdef YYFALLBACK
static const YYCODETYPE yyFallback[] = {
    0,  /*          $ => nothing */
    0,  /*     LOWEST => nothing */
    0,  /*   TEXTEXPR => nothing */
    0,  /*        ORX => nothing */
    0,  /*         OR => nothing */
    0,  /*   MODIFIER => nothing */
    0,  /*         RP => nothing */
    0,  /*         RB => nothing */
    0,  /*       RSQB => nothing */
    0,  /*       TERM => nothing */
    0,  /*      QUOTE => nothing */
    0,  /*         LP => nothing */
    0,  /*         LB => nothing */
    0,  /*       LSQB => nothing */
    0,  /*      TILDE => nothing */
    0,  /*      MINUS => nothing */
    0,  /*        AND => nothing */
    0,  /*      ARROW => nothing */
    0,  /*      COLON => nothing */
    0,  /*     NUMBER => nothing */
    0,  /*       SIZE => nothing */
    0,  /*   STOPWORD => nothing */
    0,  /*       STAR => nothing */
    0,  /*    TAGLIST => nothing */
    0,  /*   TERMLIST => nothing */
    0,  /*     PREFIX => nothing */
    0,  /*    PERCENT => nothing */
    0,  /*  ATTRIBUTE => nothing */
   21,  /*       AS_S => STOPWORD */
    9,  /*       AS_T => TERM */
    0,  /*  SEMICOLON => nothing */
};
#endif /* YYFALLBACK */

/* The following structure represents a single element of the
** parser's stack.  Information stored includes:
**
**   +  The state number for the parser at this level of the stack.
**
**   +  The value of the token stored at this level of the stack.
**      (In other words, the "major" token.)
**
**   +  The semantic value stored at this level of the stack.  This is
**      the information used by the action routines in the grammar.
**      It is sometimes called the "minor" token.
**
** After the "shift" half of a SHIFTREDUCE action, the stateno field
** actually contains the reduce action for the second half of the
** SHIFTREDUCE.
*/
struct yyStackEntry {
  YYACTIONTYPE stateno;  /* The state-number, or reduce action in SHIFTREDUCE */
  YYCODETYPE major;      /* The major token value.  This is the code
                         ** number for the token at this stack level */
  YYMINORTYPE minor;     /* The user-supplied minor token value.  This
                         ** is the value of the token  */
};
typedef struct yyStackEntry yyStackEntry;

/* The state of the parser is completely contained in an instance of
** the following structure */
struct yyParser {
  yyStackEntry *yytos;          /* Pointer to top element of the stack */
#ifdef YYTRACKMAXSTACKDEPTH
  int yyhwm;                    /* High-water mark of the stack */
#endif
#ifndef YYNOERRORRECOVERY
  int yyerrcnt;                 /* Shifts left before out of the error */
#endif
  RSQueryParser_v2_ARG_SDECL                /* A place to hold %extra_argument */
  RSQueryParser_v2_CTX_SDECL                /* A place to hold %extra_context */
#if YYSTACKDEPTH<=0
  int yystksz;                  /* Current side of the stack */
  yyStackEntry *yystack;        /* The parser's stack */
  yyStackEntry yystk0;          /* First stack entry */
#else
  yyStackEntry yystack[YYSTACKDEPTH];  /* The parser's stack */
  yyStackEntry *yystackEnd;            /* Last entry in the stack */
#endif
};
typedef struct yyParser yyParser;

#include <assert.h>
#ifndef NDEBUG
#include <stdio.h>
static FILE *yyTraceFILE = 0;
static char *yyTracePrompt = 0;
#endif /* NDEBUG */

#ifndef NDEBUG
/* 
** Turn parser tracing on by giving a stream to which to write the trace
** and a prompt to preface each trace message.  Tracing is turned off
** by making either argument NULL 
**
** Inputs:
** <ul>
** <li> A FILE* to which trace output should be written.
**      If NULL, then tracing is turned off.
** <li> A prefix string written at the beginning of every
**      line of trace output.  If NULL, then tracing is
**      turned off.
** </ul>
**
** Outputs:
** None.
*/
void RSQueryParser_v2_Trace(FILE *TraceFILE, char *zTracePrompt){
  yyTraceFILE = TraceFILE;
  yyTracePrompt = zTracePrompt;
  if( yyTraceFILE==0 ) yyTracePrompt = 0;
  else if( yyTracePrompt==0 ) yyTraceFILE = 0;
}
#endif /* NDEBUG */

#if defined(YYCOVERAGE) || !defined(NDEBUG)
/* For tracing shifts, the names of all terminals and nonterminals
** are required.  The following table supplies these names */
static const char *const yyTokenName[] = { 
  /*    0 */ "$",
  /*    1 */ "LOWEST",
  /*    2 */ "TEXTEXPR",
  /*    3 */ "ORX",
  /*    4 */ "OR",
  /*    5 */ "MODIFIER",
  /*    6 */ "RP",
  /*    7 */ "RB",
  /*    8 */ "RSQB",
  /*    9 */ "TERM",
  /*   10 */ "QUOTE",
  /*   11 */ "LP",
  /*   12 */ "LB",
  /*   13 */ "LSQB",
  /*   14 */ "TILDE",
  /*   15 */ "MINUS",
  /*   16 */ "AND",
  /*   17 */ "ARROW",
  /*   18 */ "COLON",
  /*   19 */ "NUMBER",
  /*   20 */ "SIZE",
  /*   21 */ "STOPWORD",
  /*   22 */ "STAR",
  /*   23 */ "TAGLIST",
  /*   24 */ "TERMLIST",
  /*   25 */ "PREFIX",
  /*   26 */ "PERCENT",
  /*   27 */ "ATTRIBUTE",
  /*   28 */ "AS_S",
  /*   29 */ "AS_T",
  /*   30 */ "SEMICOLON",
  /*   31 */ "expr",
  /*   32 */ "attribute",
  /*   33 */ "attribute_list",
  /*   34 */ "prefix",
  /*   35 */ "termlist",
  /*   36 */ "union",
  /*   37 */ "text_union",
  /*   38 */ "text_expr",
  /*   39 */ "fuzzy",
  /*   40 */ "tag_list",
  /*   41 */ "geo_filter",
  /*   42 */ "vector_query",
  /*   43 */ "vector_command",
  /*   44 */ "vector_attribute",
  /*   45 */ "vector_attribute_list",
  /*   46 */ "modifierlist",
  /*   47 */ "num",
  /*   48 */ "numeric_range",
  /*   49 */ "query",
  /*   50 */ "star",
  /*   51 */ "modifier",
  /*   52 */ "param_term",
  /*   53 */ "term",
  /*   54 */ "param_any",
  /*   55 */ "vector_score_field",
  /*   56 */ "as",
  /*   57 */ "param_size",
};
#endif /* defined(YYCOVERAGE) || !defined(NDEBUG) */

#ifndef NDEBUG
/* For tracing reduce actions, the names of all rules are required.
*/
static const char *const yyRuleName[] = {
 /*   0 */ "query ::= expr",
 /*   1 */ "query ::=",
 /*   2 */ "query ::= star",
 /*   3 */ "expr ::= text_expr",
 /*   4 */ "expr ::= expr expr",
 /*   5 */ "expr ::= text_expr expr",
 /*   6 */ "expr ::= expr text_expr",
 /*   7 */ "text_expr ::= text_expr text_expr",
 /*   8 */ "expr ::= union",
 /*   9 */ "union ::= expr OR expr",
 /*  10 */ "union ::= union OR expr",
 /*  11 */ "union ::= text_expr OR expr",
 /*  12 */ "union ::= expr OR text_expr",
 /*  13 */ "text_expr ::= text_union",
 /*  14 */ "text_union ::= text_expr OR text_expr",
 /*  15 */ "text_union ::= text_union OR text_expr",
 /*  16 */ "expr ::= modifier COLON text_expr",
 /*  17 */ "expr ::= modifierlist COLON text_expr",
 /*  18 */ "expr ::= LP expr RP",
 /*  19 */ "text_expr ::= LP text_expr RP",
 /*  20 */ "attribute ::= ATTRIBUTE COLON param_term",
 /*  21 */ "attribute_list ::= attribute",
 /*  22 */ "attribute_list ::= attribute_list SEMICOLON attribute",
 /*  23 */ "attribute_list ::= attribute_list SEMICOLON",
 /*  24 */ "attribute_list ::=",
 /*  25 */ "expr ::= expr ARROW LB attribute_list RB",
 /*  26 */ "text_expr ::= text_expr ARROW LB attribute_list RB",
 /*  27 */ "text_expr ::= QUOTE termlist QUOTE",
 /*  28 */ "text_expr ::= QUOTE term QUOTE",
 /*  29 */ "text_expr ::= QUOTE ATTRIBUTE QUOTE",
 /*  30 */ "text_expr ::= param_term",
 /*  31 */ "text_expr ::= prefix",
 /*  32 */ "text_expr ::= STOPWORD",
 /*  33 */ "termlist ::= param_term param_term",
 /*  34 */ "termlist ::= termlist param_term",
 /*  35 */ "termlist ::= termlist STOPWORD",
 /*  36 */ "expr ::= MINUS expr",
 /*  37 */ "text_expr ::= MINUS text_expr",
 /*  38 */ "expr ::= TILDE expr",
 /*  39 */ "text_expr ::= TILDE text_expr",
 /*  40 */ "prefix ::= PREFIX",
 /*  41 */ "text_expr ::= PERCENT param_term PERCENT",
 /*  42 */ "text_expr ::= PERCENT PERCENT param_term PERCENT PERCENT",
 /*  43 */ "text_expr ::= PERCENT PERCENT PERCENT param_term PERCENT PERCENT PERCENT",
 /*  44 */ "text_expr ::= PERCENT STOPWORD PERCENT",
 /*  45 */ "text_expr ::= PERCENT PERCENT STOPWORD PERCENT PERCENT",
 /*  46 */ "text_expr ::= PERCENT PERCENT PERCENT STOPWORD PERCENT PERCENT PERCENT",
 /*  47 */ "modifier ::= MODIFIER",
 /*  48 */ "modifierlist ::= modifier OR term",
 /*  49 */ "modifierlist ::= modifierlist OR term",
 /*  50 */ "expr ::= modifier COLON LB tag_list RB",
 /*  51 */ "tag_list ::= param_term",
 /*  52 */ "tag_list ::= STOPWORD",
 /*  53 */ "tag_list ::= prefix",
 /*  54 */ "tag_list ::= termlist",
 /*  55 */ "tag_list ::= tag_list OR param_term",
 /*  56 */ "tag_list ::= tag_list OR STOPWORD",
 /*  57 */ "tag_list ::= tag_list OR prefix",
 /*  58 */ "tag_list ::= tag_list OR termlist",
 /*  59 */ "expr ::= modifier COLON numeric_range",
 /*  60 */ "numeric_range ::= LSQB param_any param_any RSQB",
 /*  61 */ "expr ::= modifier COLON geo_filter",
 /*  62 */ "geo_filter ::= LSQB param_any param_any param_any param_any RSQB",
 /*  63 */ "query ::= expr ARROW LSQB vector_query RSQB",
 /*  64 */ "query ::= text_expr ARROW LSQB vector_query RSQB",
 /*  65 */ "query ::= star ARROW LSQB vector_query RSQB",
 /*  66 */ "vector_query ::= vector_command vector_attribute_list vector_score_field",
 /*  67 */ "vector_query ::= vector_command vector_score_field",
 /*  68 */ "vector_query ::= vector_command vector_attribute_list",
 /*  69 */ "vector_query ::= vector_command",
 /*  70 */ "vector_score_field ::= as param_term",
 /*  71 */ "vector_score_field ::= as STOPWORD",
 /*  72 */ "vector_command ::= TERM param_size modifier ATTRIBUTE",
 /*  73 */ "vector_attribute ::= TERM param_term",
 /*  74 */ "vector_attribute_list ::= vector_attribute_list vector_attribute",
 /*  75 */ "vector_attribute_list ::= vector_attribute",
 /*  76 */ "num ::= SIZE",
 /*  77 */ "num ::= NUMBER",
 /*  78 */ "num ::= LP num",
 /*  79 */ "num ::= MINUS num",
 /*  80 */ "term ::= TERM",
 /*  81 */ "term ::= NUMBER",
 /*  82 */ "term ::= SIZE",
 /*  83 */ "param_term ::= TERM",
 /*  84 */ "param_term ::= NUMBER",
 /*  85 */ "param_term ::= SIZE",
 /*  86 */ "param_term ::= ATTRIBUTE",
 /*  87 */ "param_size ::= SIZE",
 /*  88 */ "param_size ::= ATTRIBUTE",
 /*  89 */ "param_any ::= ATTRIBUTE",
 /*  90 */ "param_any ::= LP ATTRIBUTE",
 /*  91 */ "param_any ::= TERM",
 /*  92 */ "param_any ::= num",
 /*  93 */ "star ::= STAR",
 /*  94 */ "star ::= LP star RP",
 /*  95 */ "as ::= AS_T",
 /*  96 */ "as ::= AS_S",
};
#endif /* NDEBUG */


#if YYSTACKDEPTH<=0
/*
** Try to increase the size of the parser stack.  Return the number
** of errors.  Return 0 on success.
*/
static int yyGrowStack(yyParser *p){
  int newSize;
  int idx;
  yyStackEntry *pNew;

  newSize = p->yystksz*2 + 100;
  idx = p->yytos ? (int)(p->yytos - p->yystack) : 0;
  if( p->yystack==&p->yystk0 ){
    pNew = malloc(newSize*sizeof(pNew[0]));
    if( pNew ) pNew[0] = p->yystk0;
  }else{
    pNew = realloc(p->yystack, newSize*sizeof(pNew[0]));
  }
  if( pNew ){
    p->yystack = pNew;
    p->yytos = &p->yystack[idx];
#ifndef NDEBUG
    if( yyTraceFILE ){
      fprintf(yyTraceFILE,"%sStack grows from %d to %d entries.\n",
              yyTracePrompt, p->yystksz, newSize);
    }
#endif
    p->yystksz = newSize;
  }
  return pNew==0; 
}
#endif

/* Datatype of the argument to the memory allocated passed as the
** second argument to RSQueryParser_v2_Alloc() below.  This can be changed by
** putting an appropriate #define in the %include section of the input
** grammar.
*/
#ifndef YYMALLOCARGTYPE
# define YYMALLOCARGTYPE size_t
#endif

/* Initialize a new parser that has already been allocated.
*/
void RSQueryParser_v2_Init(void *yypRawParser RSQueryParser_v2_CTX_PDECL){
  yyParser *yypParser = (yyParser*)yypRawParser;
  RSQueryParser_v2_CTX_STORE
#ifdef YYTRACKMAXSTACKDEPTH
  yypParser->yyhwm = 0;
#endif
#if YYSTACKDEPTH<=0
  yypParser->yytos = NULL;
  yypParser->yystack = NULL;
  yypParser->yystksz = 0;
  if( yyGrowStack(yypParser) ){
    yypParser->yystack = &yypParser->yystk0;
    yypParser->yystksz = 1;
  }
#endif
#ifndef YYNOERRORRECOVERY
  yypParser->yyerrcnt = -1;
#endif
  yypParser->yytos = yypParser->yystack;
  yypParser->yystack[0].stateno = 0;
  yypParser->yystack[0].major = 0;
#if YYSTACKDEPTH>0
  yypParser->yystackEnd = &yypParser->yystack[YYSTACKDEPTH-1];
#endif
}

#ifndef RSQueryParser_v2__ENGINEALWAYSONSTACK
/* 
** This function allocates a new parser.
** The only argument is a pointer to a function which works like
** malloc.
**
** Inputs:
** A pointer to the function used to allocate memory.
**
** Outputs:
** A pointer to a parser.  This pointer is used in subsequent calls
** to RSQueryParser_v2_ and RSQueryParser_v2_Free.
*/
void *RSQueryParser_v2_Alloc(void *(*mallocProc)(YYMALLOCARGTYPE) RSQueryParser_v2_CTX_PDECL){
  yyParser *yypParser;
  yypParser = (yyParser*)(*mallocProc)( (YYMALLOCARGTYPE)sizeof(yyParser) );
  if( yypParser ){
    RSQueryParser_v2_CTX_STORE
    RSQueryParser_v2_Init(yypParser RSQueryParser_v2_CTX_PARAM);
  }
  return (void*)yypParser;
}
#endif /* RSQueryParser_v2__ENGINEALWAYSONSTACK */


/* The following function deletes the "minor type" or semantic value
** associated with a symbol.  The symbol can be either a terminal
** or nonterminal. "yymajor" is the symbol code, and "yypminor" is
** a pointer to the value to be deleted.  The code used to do the 
** deletions is derived from the %destructor and/or %token_destructor
** directives of the input grammar.
*/
static void yy_destructor(
  yyParser *yypParser,    /* The parser */
  YYCODETYPE yymajor,     /* Type code for object to destroy */
  YYMINORTYPE *yypminor   /* The object to be destroyed */
){
  RSQueryParser_v2_ARG_FETCH
  RSQueryParser_v2_CTX_FETCH
  switch( yymajor ){
    /* Here is inserted the actions which take place when a
    ** terminal or non-terminal is destroyed.  This can happen
    ** when the symbol is popped from the stack during a
    ** reduce or during error processing or when a parser is 
    ** being destroyed before it is finished parsing.
    **
    ** Note: during a reduce, the only symbols destroyed are those
    ** which appear on the RHS of the rule, but which are *not* used
    ** inside the C code.
    */
/********* Begin destructor definitions ***************************************/
      /* Default NON-TERMINAL Destructor */
    case 44: /* vector_attribute */
    case 47: /* num */
    case 49: /* query */
    case 50: /* star */
    case 51: /* modifier */
    case 52: /* param_term */
    case 53: /* term */
    case 54: /* param_any */
    case 55: /* vector_score_field */
    case 56: /* as */
    case 57: /* param_size */
{
 
}
      break;
    case 31: /* expr */
    case 34: /* prefix */
    case 35: /* termlist */
    case 36: /* union */
    case 37: /* text_union */
    case 38: /* text_expr */
    case 39: /* fuzzy */
    case 40: /* tag_list */
    case 42: /* vector_query */
    case 43: /* vector_command */
{
 QueryNode_Free((yypminor->yy111)); 
}
      break;
    case 32: /* attribute */
{
 rm_free((char*)(yypminor->yy59).value); 
}
      break;
    case 33: /* attribute_list */
{
 array_free_ex((yypminor->yy17), rm_free((char*)((QueryAttribute*)ptr )->value)); 
}
      break;
    case 41: /* geo_filter */
{
 QueryParam_Free((yypminor->yy22)); 
}
      break;
    case 45: /* vector_attribute_list */
{

  array_free((yypminor->yy102).needResolve);
  array_free_ex((yypminor->yy102).params, {
    rm_free((char*)((VecSimRawParam*)ptr)->value);
    rm_free((char*)((VecSimRawParam*)ptr)->name);
  });

}
      break;
    case 46: /* modifierlist */
{

    for (size_t i = 0; i < Vector_Size((yypminor->yy103)); i++) {
        char *s;
        Vector_Get((yypminor->yy103), i, &s);
        rm_free(s);
    }
    Vector_Free((yypminor->yy103));

}
      break;
    case 48: /* numeric_range */
{

  QueryParam_Free((yypminor->yy22));

}
      break;
/********* End destructor definitions *****************************************/
    default:  break;   /* If no destructor action specified: do nothing */
  }
}

/*
** Pop the parser's stack once.
**
** If there is a destructor routine associated with the token which
** is popped from the stack, then call it.
*/
static void yy_pop_parser_stack(yyParser *pParser){
  yyStackEntry *yytos;
  assert( pParser->yytos!=0 );
  assert( pParser->yytos > pParser->yystack );
  yytos = pParser->yytos--;
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sPopping %s\n",
      yyTracePrompt,
      yyTokenName[yytos->major]);
  }
#endif
  yy_destructor(pParser, yytos->major, &yytos->minor);
}

/*
** Clear all secondary memory allocations from the parser
*/
void RSQueryParser_v2_Finalize(void *p){
  yyParser *pParser = (yyParser*)p;
  while( pParser->yytos>pParser->yystack ) yy_pop_parser_stack(pParser);
#if YYSTACKDEPTH<=0
  if( pParser->yystack!=&pParser->yystk0 ) free(pParser->yystack);
#endif
}

#ifndef RSQueryParser_v2__ENGINEALWAYSONSTACK
/* 
** Deallocate and destroy a parser.  Destructors are called for
** all stack elements before shutting the parser down.
**
** If the YYPARSEFREENEVERNULL macro exists (for example because it
** is defined in a %include section of the input grammar) then it is
** assumed that the input pointer is never NULL.
*/
void RSQueryParser_v2_Free(
  void *p,                    /* The parser to be deleted */
  void (*freeProc)(void*)     /* Function used to reclaim memory */
){
#ifndef YYPARSEFREENEVERNULL
  if( p==0 ) return;
#endif
  RSQueryParser_v2_Finalize(p);
  (*freeProc)(p);
}
#endif /* RSQueryParser_v2__ENGINEALWAYSONSTACK */

/*
** Return the peak depth of the stack for a parser.
*/
#ifdef YYTRACKMAXSTACKDEPTH
int RSQueryParser_v2_StackPeak(void *p){
  yyParser *pParser = (yyParser*)p;
  return pParser->yyhwm;
}
#endif

/* This array of booleans keeps track of the parser statement
** coverage.  The element yycoverage[X][Y] is set when the parser
** is in state X and has a lookahead token Y.  In a well-tested
** systems, every element of this matrix should end up being set.
*/
#if defined(YYCOVERAGE)
static unsigned char yycoverage[YYNSTATE][YYNTOKEN];
#endif

/*
** Write into out a description of every state/lookahead combination that
**
**   (1)  has not been used by the parser, and
**   (2)  is not a syntax error.
**
** Return the number of missed state/lookahead combinations.
*/
#if defined(YYCOVERAGE)
int RSQueryParser_v2_Coverage(FILE *out){
  int stateno, iLookAhead, i;
  int nMissed = 0;
  for(stateno=0; stateno<YYNSTATE; stateno++){
    i = yy_shift_ofst[stateno];
    for(iLookAhead=0; iLookAhead<YYNTOKEN; iLookAhead++){
      if( yy_lookahead[i+iLookAhead]!=iLookAhead ) continue;
      if( yycoverage[stateno][iLookAhead]==0 ) nMissed++;
      if( out ){
        fprintf(out,"State %d lookahead %s %s\n", stateno,
                yyTokenName[iLookAhead],
                yycoverage[stateno][iLookAhead] ? "ok" : "missed");
      }
    }
  }
  return nMissed;
}
#endif

/*
** Find the appropriate action for a parser given the terminal
** look-ahead token iLookAhead.
*/
static YYACTIONTYPE yy_find_shift_action(
  YYCODETYPE iLookAhead,    /* The look-ahead token */
  YYACTIONTYPE stateno      /* Current state number */
){
  int i;

  if( stateno>YY_MAX_SHIFT ) return stateno;
  assert( stateno <= YY_SHIFT_COUNT );
#if defined(YYCOVERAGE)
  yycoverage[stateno][iLookAhead] = 1;
#endif
  do{
    i = yy_shift_ofst[stateno];
    assert( i>=0 );
    assert( i<=YY_ACTTAB_COUNT );
    assert( i+YYNTOKEN<=(int)YY_NLOOKAHEAD );
    assert( iLookAhead!=YYNOCODE );
    assert( iLookAhead < YYNTOKEN );
    i += iLookAhead;
    assert( i<(int)YY_NLOOKAHEAD );
    if( yy_lookahead[i]!=iLookAhead ){
#ifdef YYFALLBACK
      YYCODETYPE iFallback;            /* Fallback token */
      assert( iLookAhead<sizeof(yyFallback)/sizeof(yyFallback[0]) );
      iFallback = yyFallback[iLookAhead];
      if( iFallback!=0 ){
#ifndef NDEBUG
        if( yyTraceFILE ){
          fprintf(yyTraceFILE, "%sFALLBACK %s => %s\n",
             yyTracePrompt, yyTokenName[iLookAhead], yyTokenName[iFallback]);
        }
#endif
        assert( yyFallback[iFallback]==0 ); /* Fallback loop must terminate */
        iLookAhead = iFallback;
        continue;
      }
#endif
#ifdef YYWILDCARD
      {
        int j = i - iLookAhead + YYWILDCARD;
        assert( j<(int)(sizeof(yy_lookahead)/sizeof(yy_lookahead[0])) );
        if( yy_lookahead[j]==YYWILDCARD && iLookAhead>0 ){
#ifndef NDEBUG
          if( yyTraceFILE ){
            fprintf(yyTraceFILE, "%sWILDCARD %s => %s\n",
               yyTracePrompt, yyTokenName[iLookAhead],
               yyTokenName[YYWILDCARD]);
          }
#endif /* NDEBUG */
          return yy_action[j];
        }
      }
#endif /* YYWILDCARD */
      return yy_default[stateno];
    }else{
      assert( i>=0 && i<(int)(sizeof(yy_action)/sizeof(yy_action[0])) );
      return yy_action[i];
    }
  }while(1);
}

/*
** Find the appropriate action for a parser given the non-terminal
** look-ahead token iLookAhead.
*/
static YYACTIONTYPE yy_find_reduce_action(
  YYACTIONTYPE stateno,     /* Current state number */
  YYCODETYPE iLookAhead     /* The look-ahead token */
){
  int i;
#ifdef YYERRORSYMBOL
  if( stateno>YY_REDUCE_COUNT ){
    return yy_default[stateno];
  }
#else
  assert( stateno<=YY_REDUCE_COUNT );
#endif
  i = yy_reduce_ofst[stateno];
  assert( iLookAhead!=YYNOCODE );
  i += iLookAhead;
#ifdef YYERRORSYMBOL
  if( i<0 || i>=YY_ACTTAB_COUNT || yy_lookahead[i]!=iLookAhead ){
    return yy_default[stateno];
  }
#else
  assert( i>=0 && i<YY_ACTTAB_COUNT );
  assert( yy_lookahead[i]==iLookAhead );
#endif
  return yy_action[i];
}

/*
** The following routine is called if the stack overflows.
*/
static void yyStackOverflow(yyParser *yypParser){
   RSQueryParser_v2_ARG_FETCH
   RSQueryParser_v2_CTX_FETCH
#ifndef NDEBUG
   if( yyTraceFILE ){
     fprintf(yyTraceFILE,"%sStack Overflow!\n",yyTracePrompt);
   }
#endif
   while( yypParser->yytos>yypParser->yystack ) yy_pop_parser_stack(yypParser);
   /* Here code is inserted which will execute if the parser
   ** stack every overflows */
/******** Begin %stack_overflow code ******************************************/

  QueryError_SetErrorFmt(ctx->status, QUERY_ESYNTAX,
    "Parser stack overflow. Try moving nested parentheses more to the left");
/******** End %stack_overflow code ********************************************/
   RSQueryParser_v2_ARG_STORE /* Suppress warning about unused %extra_argument var */
   RSQueryParser_v2_CTX_STORE
}

/*
** Print tracing information for a SHIFT action
*/
#ifndef NDEBUG
static void yyTraceShift(yyParser *yypParser, int yyNewState, const char *zTag){
  if( yyTraceFILE ){
    if( yyNewState<YYNSTATE ){
      fprintf(yyTraceFILE,"%s%s '%s', go to state %d\n",
         yyTracePrompt, zTag, yyTokenName[yypParser->yytos->major],
         yyNewState);
    }else{
      fprintf(yyTraceFILE,"%s%s '%s', pending reduce %d\n",
         yyTracePrompt, zTag, yyTokenName[yypParser->yytos->major],
         yyNewState - YY_MIN_REDUCE);
    }
  }
}
#else
# define yyTraceShift(X,Y,Z)
#endif

/*
** Perform a shift action.
*/
static void yy_shift(
  yyParser *yypParser,          /* The parser to be shifted */
  YYACTIONTYPE yyNewState,      /* The new state to shift in */
  YYCODETYPE yyMajor,           /* The major token to shift in */
  RSQueryParser_v2_TOKENTYPE yyMinor        /* The minor token to shift in */
){
  yyStackEntry *yytos;
  yypParser->yytos++;
#ifdef YYTRACKMAXSTACKDEPTH
  if( (int)(yypParser->yytos - yypParser->yystack)>yypParser->yyhwm ){
    yypParser->yyhwm++;
    assert( yypParser->yyhwm == (int)(yypParser->yytos - yypParser->yystack) );
  }
#endif
#if YYSTACKDEPTH>0 
  if( yypParser->yytos>yypParser->yystackEnd ){
    yypParser->yytos--;
    yyStackOverflow(yypParser);
    return;
  }
#else
  if( yypParser->yytos>=&yypParser->yystack[yypParser->yystksz] ){
    if( yyGrowStack(yypParser) ){
      yypParser->yytos--;
      yyStackOverflow(yypParser);
      return;
    }
  }
#endif
  if( yyNewState > YY_MAX_SHIFT ){
    yyNewState += YY_MIN_REDUCE - YY_MIN_SHIFTREDUCE;
  }
  yytos = yypParser->yytos;
  yytos->stateno = yyNewState;
  yytos->major = yyMajor;
  yytos->minor.yy0 = yyMinor;
  yyTraceShift(yypParser, yyNewState, "Shift");
}

/* For rule J, yyRuleInfoLhs[J] contains the symbol on the left-hand side
** of that rule */
static const YYCODETYPE yyRuleInfoLhs[] = {
    49,  /* (0) query ::= expr */
    49,  /* (1) query ::= */
    49,  /* (2) query ::= star */
    31,  /* (3) expr ::= text_expr */
    31,  /* (4) expr ::= expr expr */
    31,  /* (5) expr ::= text_expr expr */
    31,  /* (6) expr ::= expr text_expr */
    38,  /* (7) text_expr ::= text_expr text_expr */
    31,  /* (8) expr ::= union */
    36,  /* (9) union ::= expr OR expr */
    36,  /* (10) union ::= union OR expr */
    36,  /* (11) union ::= text_expr OR expr */
    36,  /* (12) union ::= expr OR text_expr */
    38,  /* (13) text_expr ::= text_union */
    37,  /* (14) text_union ::= text_expr OR text_expr */
    37,  /* (15) text_union ::= text_union OR text_expr */
    31,  /* (16) expr ::= modifier COLON text_expr */
    31,  /* (17) expr ::= modifierlist COLON text_expr */
    31,  /* (18) expr ::= LP expr RP */
    38,  /* (19) text_expr ::= LP text_expr RP */
    32,  /* (20) attribute ::= ATTRIBUTE COLON param_term */
    33,  /* (21) attribute_list ::= attribute */
    33,  /* (22) attribute_list ::= attribute_list SEMICOLON attribute */
    33,  /* (23) attribute_list ::= attribute_list SEMICOLON */
    33,  /* (24) attribute_list ::= */
    31,  /* (25) expr ::= expr ARROW LB attribute_list RB */
    38,  /* (26) text_expr ::= text_expr ARROW LB attribute_list RB */
    38,  /* (27) text_expr ::= QUOTE termlist QUOTE */
    38,  /* (28) text_expr ::= QUOTE term QUOTE */
    38,  /* (29) text_expr ::= QUOTE ATTRIBUTE QUOTE */
    38,  /* (30) text_expr ::= param_term */
    38,  /* (31) text_expr ::= prefix */
    38,  /* (32) text_expr ::= STOPWORD */
    35,  /* (33) termlist ::= param_term param_term */
    35,  /* (34) termlist ::= termlist param_term */
    35,  /* (35) termlist ::= termlist STOPWORD */
    31,  /* (36) expr ::= MINUS expr */
    38,  /* (37) text_expr ::= MINUS text_expr */
    31,  /* (38) expr ::= TILDE expr */
    38,  /* (39) text_expr ::= TILDE text_expr */
    34,  /* (40) prefix ::= PREFIX */
    38,  /* (41) text_expr ::= PERCENT param_term PERCENT */
    38,  /* (42) text_expr ::= PERCENT PERCENT param_term PERCENT PERCENT */
    38,  /* (43) text_expr ::= PERCENT PERCENT PERCENT param_term PERCENT PERCENT PERCENT */
    38,  /* (44) text_expr ::= PERCENT STOPWORD PERCENT */
    38,  /* (45) text_expr ::= PERCENT PERCENT STOPWORD PERCENT PERCENT */
    38,  /* (46) text_expr ::= PERCENT PERCENT PERCENT STOPWORD PERCENT PERCENT PERCENT */
    51,  /* (47) modifier ::= MODIFIER */
    46,  /* (48) modifierlist ::= modifier OR term */
    46,  /* (49) modifierlist ::= modifierlist OR term */
    31,  /* (50) expr ::= modifier COLON LB tag_list RB */
    40,  /* (51) tag_list ::= param_term */
    40,  /* (52) tag_list ::= STOPWORD */
    40,  /* (53) tag_list ::= prefix */
    40,  /* (54) tag_list ::= termlist */
    40,  /* (55) tag_list ::= tag_list OR param_term */
    40,  /* (56) tag_list ::= tag_list OR STOPWORD */
    40,  /* (57) tag_list ::= tag_list OR prefix */
    40,  /* (58) tag_list ::= tag_list OR termlist */
    31,  /* (59) expr ::= modifier COLON numeric_range */
    48,  /* (60) numeric_range ::= LSQB param_any param_any RSQB */
    31,  /* (61) expr ::= modifier COLON geo_filter */
    41,  /* (62) geo_filter ::= LSQB param_any param_any param_any param_any RSQB */
    49,  /* (63) query ::= expr ARROW LSQB vector_query RSQB */
    49,  /* (64) query ::= text_expr ARROW LSQB vector_query RSQB */
    49,  /* (65) query ::= star ARROW LSQB vector_query RSQB */
    42,  /* (66) vector_query ::= vector_command vector_attribute_list vector_score_field */
    42,  /* (67) vector_query ::= vector_command vector_score_field */
    42,  /* (68) vector_query ::= vector_command vector_attribute_list */
    42,  /* (69) vector_query ::= vector_command */
    55,  /* (70) vector_score_field ::= as param_term */
    55,  /* (71) vector_score_field ::= as STOPWORD */
    43,  /* (72) vector_command ::= TERM param_size modifier ATTRIBUTE */
    44,  /* (73) vector_attribute ::= TERM param_term */
    45,  /* (74) vector_attribute_list ::= vector_attribute_list vector_attribute */
    45,  /* (75) vector_attribute_list ::= vector_attribute */
    47,  /* (76) num ::= SIZE */
    47,  /* (77) num ::= NUMBER */
    47,  /* (78) num ::= LP num */
    47,  /* (79) num ::= MINUS num */
    53,  /* (80) term ::= TERM */
    53,  /* (81) term ::= NUMBER */
    53,  /* (82) term ::= SIZE */
    52,  /* (83) param_term ::= TERM */
    52,  /* (84) param_term ::= NUMBER */
    52,  /* (85) param_term ::= SIZE */
    52,  /* (86) param_term ::= ATTRIBUTE */
    57,  /* (87) param_size ::= SIZE */
    57,  /* (88) param_size ::= ATTRIBUTE */
    54,  /* (89) param_any ::= ATTRIBUTE */
    54,  /* (90) param_any ::= LP ATTRIBUTE */
    54,  /* (91) param_any ::= TERM */
    54,  /* (92) param_any ::= num */
    50,  /* (93) star ::= STAR */
    50,  /* (94) star ::= LP star RP */
    56,  /* (95) as ::= AS_T */
    56,  /* (96) as ::= AS_S */
};

/* For rule J, yyRuleInfoNRhs[J] contains the negative of the number
** of symbols on the right-hand side of that rule. */
static const signed char yyRuleInfoNRhs[] = {
   -1,  /* (0) query ::= expr */
    0,  /* (1) query ::= */
   -1,  /* (2) query ::= star */
   -1,  /* (3) expr ::= text_expr */
   -2,  /* (4) expr ::= expr expr */
   -2,  /* (5) expr ::= text_expr expr */
   -2,  /* (6) expr ::= expr text_expr */
   -2,  /* (7) text_expr ::= text_expr text_expr */
   -1,  /* (8) expr ::= union */
   -3,  /* (9) union ::= expr OR expr */
   -3,  /* (10) union ::= union OR expr */
   -3,  /* (11) union ::= text_expr OR expr */
   -3,  /* (12) union ::= expr OR text_expr */
   -1,  /* (13) text_expr ::= text_union */
   -3,  /* (14) text_union ::= text_expr OR text_expr */
   -3,  /* (15) text_union ::= text_union OR text_expr */
   -3,  /* (16) expr ::= modifier COLON text_expr */
   -3,  /* (17) expr ::= modifierlist COLON text_expr */
   -3,  /* (18) expr ::= LP expr RP */
   -3,  /* (19) text_expr ::= LP text_expr RP */
   -3,  /* (20) attribute ::= ATTRIBUTE COLON param_term */
   -1,  /* (21) attribute_list ::= attribute */
   -3,  /* (22) attribute_list ::= attribute_list SEMICOLON attribute */
   -2,  /* (23) attribute_list ::= attribute_list SEMICOLON */
    0,  /* (24) attribute_list ::= */
   -5,  /* (25) expr ::= expr ARROW LB attribute_list RB */
   -5,  /* (26) text_expr ::= text_expr ARROW LB attribute_list RB */
   -3,  /* (27) text_expr ::= QUOTE termlist QUOTE */
   -3,  /* (28) text_expr ::= QUOTE term QUOTE */
   -3,  /* (29) text_expr ::= QUOTE ATTRIBUTE QUOTE */
   -1,  /* (30) text_expr ::= param_term */
   -1,  /* (31) text_expr ::= prefix */
   -1,  /* (32) text_expr ::= STOPWORD */
   -2,  /* (33) termlist ::= param_term param_term */
   -2,  /* (34) termlist ::= termlist param_term */
   -2,  /* (35) termlist ::= termlist STOPWORD */
   -2,  /* (36) expr ::= MINUS expr */
   -2,  /* (37) text_expr ::= MINUS text_expr */
   -2,  /* (38) expr ::= TILDE expr */
   -2,  /* (39) text_expr ::= TILDE text_expr */
   -1,  /* (40) prefix ::= PREFIX */
   -3,  /* (41) text_expr ::= PERCENT param_term PERCENT */
   -5,  /* (42) text_expr ::= PERCENT PERCENT param_term PERCENT PERCENT */
   -7,  /* (43) text_expr ::= PERCENT PERCENT PERCENT param_term PERCENT PERCENT PERCENT */
   -3,  /* (44) text_expr ::= PERCENT STOPWORD PERCENT */
   -5,  /* (45) text_expr ::= PERCENT PERCENT STOPWORD PERCENT PERCENT */
   -7,  /* (46) text_expr ::= PERCENT PERCENT PERCENT STOPWORD PERCENT PERCENT PERCENT */
   -1,  /* (47) modifier ::= MODIFIER */
   -3,  /* (48) modifierlist ::= modifier OR term */
   -3,  /* (49) modifierlist ::= modifierlist OR term */
   -5,  /* (50) expr ::= modifier COLON LB tag_list RB */
   -1,  /* (51) tag_list ::= param_term */
   -1,  /* (52) tag_list ::= STOPWORD */
   -1,  /* (53) tag_list ::= prefix */
   -1,  /* (54) tag_list ::= termlist */
   -3,  /* (55) tag_list ::= tag_list OR param_term */
   -3,  /* (56) tag_list ::= tag_list OR STOPWORD */
   -3,  /* (57) tag_list ::= tag_list OR prefix */
   -3,  /* (58) tag_list ::= tag_list OR termlist */
   -3,  /* (59) expr ::= modifier COLON numeric_range */
   -4,  /* (60) numeric_range ::= LSQB param_any param_any RSQB */
   -3,  /* (61) expr ::= modifier COLON geo_filter */
   -6,  /* (62) geo_filter ::= LSQB param_any param_any param_any param_any RSQB */
   -5,  /* (63) query ::= expr ARROW LSQB vector_query RSQB */
   -5,  /* (64) query ::= text_expr ARROW LSQB vector_query RSQB */
   -5,  /* (65) query ::= star ARROW LSQB vector_query RSQB */
   -3,  /* (66) vector_query ::= vector_command vector_attribute_list vector_score_field */
   -2,  /* (67) vector_query ::= vector_command vector_score_field */
   -2,  /* (68) vector_query ::= vector_command vector_attribute_list */
   -1,  /* (69) vector_query ::= vector_command */
   -2,  /* (70) vector_score_field ::= as param_term */
   -2,  /* (71) vector_score_field ::= as STOPWORD */
   -4,  /* (72) vector_command ::= TERM param_size modifier ATTRIBUTE */
   -2,  /* (73) vector_attribute ::= TERM param_term */
   -2,  /* (74) vector_attribute_list ::= vector_attribute_list vector_attribute */
   -1,  /* (75) vector_attribute_list ::= vector_attribute */
   -1,  /* (76) num ::= SIZE */
   -1,  /* (77) num ::= NUMBER */
   -2,  /* (78) num ::= LP num */
   -2,  /* (79) num ::= MINUS num */
   -1,  /* (80) term ::= TERM */
   -1,  /* (81) term ::= NUMBER */
   -1,  /* (82) term ::= SIZE */
   -1,  /* (83) param_term ::= TERM */
   -1,  /* (84) param_term ::= NUMBER */
   -1,  /* (85) param_term ::= SIZE */
   -1,  /* (86) param_term ::= ATTRIBUTE */
   -1,  /* (87) param_size ::= SIZE */
   -1,  /* (88) param_size ::= ATTRIBUTE */
   -1,  /* (89) param_any ::= ATTRIBUTE */
   -2,  /* (90) param_any ::= LP ATTRIBUTE */
   -1,  /* (91) param_any ::= TERM */
   -1,  /* (92) param_any ::= num */
   -1,  /* (93) star ::= STAR */
   -3,  /* (94) star ::= LP star RP */
   -1,  /* (95) as ::= AS_T */
   -1,  /* (96) as ::= AS_S */
};

static void yy_accept(yyParser*);  /* Forward Declaration */

/*
** Perform a reduce action and the shift that must immediately
** follow the reduce.
**
** The yyLookahead and yyLookaheadToken parameters provide reduce actions
** access to the lookahead token (if any).  The yyLookahead will be YYNOCODE
** if the lookahead token has already been consumed.  As this procedure is
** only called from one place, optimizing compilers will in-line it, which
** means that the extra parameters have no performance impact.
*/
static YYACTIONTYPE yy_reduce(
  yyParser *yypParser,         /* The parser */
  unsigned int yyruleno,       /* Number of the rule by which to reduce */
  int yyLookahead,             /* Lookahead token, or YYNOCODE if none */
  RSQueryParser_v2_TOKENTYPE yyLookaheadToken  /* Value of the lookahead token */
  RSQueryParser_v2_CTX_PDECL                   /* %extra_context */
){
  int yygoto;                     /* The next state */
  YYACTIONTYPE yyact;             /* The next action */
  yyStackEntry *yymsp;            /* The top of the parser's stack */
  int yysize;                     /* Amount to pop the stack */
  RSQueryParser_v2_ARG_FETCH
  (void)yyLookahead;
  (void)yyLookaheadToken;
  yymsp = yypParser->yytos;

  switch( yyruleno ){
  /* Beginning here are the reduction cases.  A typical example
  ** follows:
  **   case 0:
  **  #line <lineno> <grammarfile>
  **     { ... }           // User supplied code
  **  #line <lineno> <thisfile>
  **     break;
  */
/********** Begin reduce actions **********************************************/
        YYMINORTYPE yylhsminor;
      case 0: /* query ::= expr */
{
  setup_trace(ctx);
  ctx->root = yymsp[0].minor.yy111;
}
        break;
      case 1: /* query ::= */
{
  ctx->root = NULL;
}
        break;
      case 2: /* query ::= star */
{  yy_destructor(yypParser,50,&yymsp[0].minor);
{
  setup_trace(ctx);
  ctx->root = NewWildcardNode();
}
}
        break;
      case 3: /* expr ::= text_expr */
      case 8: /* expr ::= union */ yytestcase(yyruleno==8);
      case 13: /* text_expr ::= text_union */ yytestcase(yyruleno==13);
      case 69: /* vector_query ::= vector_command */ yytestcase(yyruleno==69);
{
  yylhsminor.yy111 = yymsp[0].minor.yy111;
}
  yymsp[0].minor.yy111 = yylhsminor.yy111;
        break;
      case 4: /* expr ::= expr expr */
      case 5: /* expr ::= text_expr expr */ yytestcase(yyruleno==5);
      case 6: /* expr ::= expr text_expr */ yytestcase(yyruleno==6);
      case 7: /* text_expr ::= text_expr text_expr */ yytestcase(yyruleno==7);
{
    int rv = one_not_null(yymsp[-1].minor.yy111, yymsp[0].minor.yy111, (void**)&yylhsminor.yy111);
    if (rv == NODENN_BOTH_INVALID) {
        yylhsminor.yy111 = NULL;
    } else if (rv == NODENN_ONE_NULL) {
        // Nothing- `out` is already assigned
    } else {
        if (yymsp[-1].minor.yy111 && yymsp[-1].minor.yy111->type == QN_PHRASE && yymsp[-1].minor.yy111->pn.exact == 0 &&
            yymsp[-1].minor.yy111->opts.fieldMask == RS_FIELDMASK_ALL ) {
            yylhsminor.yy111 = yymsp[-1].minor.yy111;
        } else {
            yylhsminor.yy111 = NewPhraseNode(0);
            QueryNode_AddChild(yylhsminor.yy111, yymsp[-1].minor.yy111);
        }
        QueryNode_AddChild(yylhsminor.yy111, yymsp[0].minor.yy111);
    }
}
  yymsp[-1].minor.yy111 = yylhsminor.yy111;
        break;
      case 9: /* union ::= expr OR expr */
      case 11: /* union ::= text_expr OR expr */ yytestcase(yyruleno==11);
      case 12: /* union ::= expr OR text_expr */ yytestcase(yyruleno==12);
      case 14: /* text_union ::= text_expr OR text_expr */ yytestcase(yyruleno==14);
{
    int rv = one_not_null(yymsp[-2].minor.yy111, yymsp[0].minor.yy111, (void**)&yylhsminor.yy111);
    if (rv == NODENN_BOTH_INVALID) {
        yylhsminor.yy111 = NULL;
    } else if (rv == NODENN_ONE_NULL) {
        // Nothing- already assigned
    } else {
        if (yymsp[-2].minor.yy111->type == QN_UNION && yymsp[-2].minor.yy111->opts.fieldMask == RS_FIELDMASK_ALL) {
            yylhsminor.yy111 = yymsp[-2].minor.yy111;
        } else {
            yylhsminor.yy111 = NewUnionNode();
            QueryNode_AddChild(yylhsminor.yy111, yymsp[-2].minor.yy111);
            yylhsminor.yy111->opts.fieldMask |= yymsp[-2].minor.yy111->opts.fieldMask;
        }
        // Handle yymsp[0].minor.yy111
        QueryNode_AddChild(yylhsminor.yy111, yymsp[0].minor.yy111);
        yylhsminor.yy111->opts.fieldMask |= yymsp[0].minor.yy111->opts.fieldMask;
        QueryNode_SetFieldMask(yylhsminor.yy111, yylhsminor.yy111->opts.fieldMask);
    }
}
  yymsp[-2].minor.yy111 = yylhsminor.yy111;
        break;
      case 10: /* union ::= union OR expr */
      case 15: /* text_union ::= text_union OR text_expr */ yytestcase(yyruleno==15);
{
    yylhsminor.yy111 = yymsp[-2].minor.yy111;
    if (yymsp[0].minor.yy111) {
        QueryNode_AddChild(yylhsminor.yy111, yymsp[0].minor.yy111);
        yylhsminor.yy111->opts.fieldMask |= yymsp[0].minor.yy111->opts.fieldMask;
        QueryNode_SetFieldMask(yymsp[0].minor.yy111, yylhsminor.yy111->opts.fieldMask);
    }
}
  yymsp[-2].minor.yy111 = yylhsminor.yy111;
        break;
      case 16: /* expr ::= modifier COLON text_expr */
{
    if (yymsp[0].minor.yy111 == NULL) {
        yylhsminor.yy111 = NULL;
    } else {
        if (ctx->sctx->spec) {
            QueryNode_SetFieldMask(yymsp[0].minor.yy111, IndexSpec_GetFieldBit(ctx->sctx->spec, yymsp[-2].minor.yy0.s, yymsp[-2].minor.yy0.len));
        }
        yylhsminor.yy111 = yymsp[0].minor.yy111;
    }
}
  yymsp[-2].minor.yy111 = yylhsminor.yy111;
        break;
      case 17: /* expr ::= modifierlist COLON text_expr */
{

    if (yymsp[0].minor.yy111 == NULL) {
        for (size_t i = 0; i < Vector_Size(yymsp[-2].minor.yy103); i++) {
          char *s;
          Vector_Get(yymsp[-2].minor.yy103, i, &s);
          rm_free(s);
        }
        Vector_Free(yymsp[-2].minor.yy103);
        yylhsminor.yy111 = NULL;
    } else {
        //yymsp[0].minor.yy111->opts.fieldMask = 0;
        t_fieldMask mask = 0;
        for (int i = 0; i < Vector_Size(yymsp[-2].minor.yy103); i++) {
            char *p;
            Vector_Get(yymsp[-2].minor.yy103, i, &p);
            if (ctx->sctx->spec) {
              mask |= IndexSpec_GetFieldBit(ctx->sctx->spec, p, strlen(p));
            }
            rm_free(p);
        }
        Vector_Free(yymsp[-2].minor.yy103);
        QueryNode_SetFieldMask(yymsp[0].minor.yy111, mask);
        yylhsminor.yy111=yymsp[0].minor.yy111;
    }
}
  yymsp[-2].minor.yy111 = yylhsminor.yy111;
        break;
      case 18: /* expr ::= LP expr RP */
      case 19: /* text_expr ::= LP text_expr RP */ yytestcase(yyruleno==19);
{
  yymsp[-2].minor.yy111 = yymsp[-1].minor.yy111;
}
        break;
      case 20: /* attribute ::= ATTRIBUTE COLON param_term */
{
  const char *value = rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len);
  size_t value_len = yymsp[0].minor.yy0.len;
  if (yymsp[0].minor.yy0.type == QT_PARAM_TERM) {
    size_t found_value_len;
    const char *found_value = Param_DictGet(ctx->opts->params, value, &found_value_len, ctx->status);
    if (found_value) {
      rm_free((char*)value);
      value = rm_strndup(found_value, found_value_len);
      value_len = found_value_len;
    }
  }
  yylhsminor.yy59 = (QueryAttribute){ .name = yymsp[-2].minor.yy0.s, .namelen = yymsp[-2].minor.yy0.len, .value = value, .vallen = value_len };
}
  yymsp[-2].minor.yy59 = yylhsminor.yy59;
        break;
      case 21: /* attribute_list ::= attribute */
{
  yylhsminor.yy17 = array_new(QueryAttribute, 2);
  yylhsminor.yy17 = array_append(yylhsminor.yy17, yymsp[0].minor.yy59);
}
  yymsp[0].minor.yy17 = yylhsminor.yy17;
        break;
      case 22: /* attribute_list ::= attribute_list SEMICOLON attribute */
{
  yylhsminor.yy17 = array_append(yymsp[-2].minor.yy17, yymsp[0].minor.yy59);
}
  yymsp[-2].minor.yy17 = yylhsminor.yy17;
        break;
      case 23: /* attribute_list ::= attribute_list SEMICOLON */
{
  yylhsminor.yy17 = yymsp[-1].minor.yy17;
}
  yymsp[-1].minor.yy17 = yylhsminor.yy17;
        break;
      case 24: /* attribute_list ::= */
{
  yymsp[1].minor.yy17 = NULL;
}
        break;
      case 25: /* expr ::= expr ARROW LB attribute_list RB */
      case 26: /* text_expr ::= text_expr ARROW LB attribute_list RB */ yytestcase(yyruleno==26);
{

    if (yymsp[-4].minor.yy111 && yymsp[-1].minor.yy17) {
        QueryNode_ApplyAttributes(yymsp[-4].minor.yy111, yymsp[-1].minor.yy17, array_len(yymsp[-1].minor.yy17), ctx->status);
    }
    array_free_ex(yymsp[-1].minor.yy17, rm_free((char*)((QueryAttribute*)ptr )->value));
    yylhsminor.yy111 = yymsp[-4].minor.yy111;
}
  yymsp[-4].minor.yy111 = yylhsminor.yy111;
        break;
      case 27: /* text_expr ::= QUOTE termlist QUOTE */
{
  // TODO: Quoted/verbatim string in termlist should not be handled as parameters
  // Also need to add the leading '$' which was consumed by the lexer
  yymsp[-1].minor.yy111->pn.exact = 1;
  yymsp[-1].minor.yy111->opts.flags |= QueryNode_Verbatim;

  yymsp[-2].minor.yy111 = yymsp[-1].minor.yy111;
}
        break;
      case 28: /* text_expr ::= QUOTE term QUOTE */
{
  yymsp[-2].minor.yy111 = NewTokenNode(ctx, rm_strdupcase(yymsp[-1].minor.yy0.s, yymsp[-1].minor.yy0.len), -1);
  yymsp[-2].minor.yy111->opts.flags |= QueryNode_Verbatim;
}
        break;
      case 29: /* text_expr ::= QUOTE ATTRIBUTE QUOTE */
{
  // Quoted/verbatim string should not be handled as parameters
  // Also need to add the leading '$' which was consumed by the lexer
  char *s = rm_malloc(yymsp[-1].minor.yy0.len + 1);
  *s = '$';
  memcpy(s + 1, yymsp[-1].minor.yy0.s, yymsp[-1].minor.yy0.len);
  yymsp[-2].minor.yy111 = NewTokenNode(ctx, rm_strdupcase(s, yymsp[-1].minor.yy0.len + 1), -1);
  rm_free(s);
  yymsp[-2].minor.yy111->opts.flags |= QueryNode_Verbatim;
}
        break;
      case 30: /* text_expr ::= param_term */
{
  yylhsminor.yy111 = NewTokenNode_WithParams(ctx, &yymsp[0].minor.yy0);
}
  yymsp[0].minor.yy111 = yylhsminor.yy111;
        break;
      case 31: /* text_expr ::= prefix */
{
yylhsminor.yy111 = yymsp[0].minor.yy111;
}
  yymsp[0].minor.yy111 = yylhsminor.yy111;
        break;
      case 32: /* text_expr ::= STOPWORD */
{
  yymsp[0].minor.yy111 = NULL;
}
        break;
      case 33: /* termlist ::= param_term param_term */
{
  yylhsminor.yy111 = NewPhraseNode(0);
  QueryNode_AddChild(yylhsminor.yy111, NewTokenNode_WithParams(ctx, &yymsp[-1].minor.yy0));
  QueryNode_AddChild(yylhsminor.yy111, NewTokenNode_WithParams(ctx, &yymsp[0].minor.yy0));
}
  yymsp[-1].minor.yy111 = yylhsminor.yy111;
        break;
      case 34: /* termlist ::= termlist param_term */
{
  yylhsminor.yy111 = yymsp[-1].minor.yy111;
  QueryNode_AddChild(yylhsminor.yy111, NewTokenNode_WithParams(ctx, &yymsp[0].minor.yy0));
}
  yymsp[-1].minor.yy111 = yylhsminor.yy111;
        break;
      case 35: /* termlist ::= termlist STOPWORD */
{
  yylhsminor.yy111 = yymsp[-1].minor.yy111;
}
  yymsp[-1].minor.yy111 = yylhsminor.yy111;
        break;
      case 36: /* expr ::= MINUS expr */
      case 37: /* text_expr ::= MINUS text_expr */ yytestcase(yyruleno==37);
{
    if (yymsp[0].minor.yy111) {
        yymsp[-1].minor.yy111 = NewNotNode(yymsp[0].minor.yy111);
    } else {
        yymsp[-1].minor.yy111 = NULL;
    }
}
        break;
      case 38: /* expr ::= TILDE expr */
      case 39: /* text_expr ::= TILDE text_expr */ yytestcase(yyruleno==39);
{
    if (yymsp[0].minor.yy111) {
        yymsp[-1].minor.yy111 = NewOptionalNode(yymsp[0].minor.yy111);
    } else {
        yymsp[-1].minor.yy111 = NULL;
    }
}
        break;
      case 40: /* prefix ::= PREFIX */
{
    yylhsminor.yy111 = NewPrefixNode_WithParams(ctx, &yymsp[0].minor.yy0);
}
  yymsp[0].minor.yy111 = yylhsminor.yy111;
        break;
      case 41: /* text_expr ::= PERCENT param_term PERCENT */
      case 44: /* text_expr ::= PERCENT STOPWORD PERCENT */ yytestcase(yyruleno==44);
{
  yymsp[-2].minor.yy111 = NewFuzzyNode_WithParams(ctx, &yymsp[-1].minor.yy0, 1);
}
        break;
      case 42: /* text_expr ::= PERCENT PERCENT param_term PERCENT PERCENT */
      case 45: /* text_expr ::= PERCENT PERCENT STOPWORD PERCENT PERCENT */ yytestcase(yyruleno==45);
{
  yymsp[-4].minor.yy111 = NewFuzzyNode_WithParams(ctx, &yymsp[-2].minor.yy0, 2);
}
        break;
      case 43: /* text_expr ::= PERCENT PERCENT PERCENT param_term PERCENT PERCENT PERCENT */
      case 46: /* text_expr ::= PERCENT PERCENT PERCENT STOPWORD PERCENT PERCENT PERCENT */ yytestcase(yyruleno==46);
{
  yymsp[-6].minor.yy111 = NewFuzzyNode_WithParams(ctx, &yymsp[-3].minor.yy0, 3);
}
        break;
      case 47: /* modifier ::= MODIFIER */
{
    yymsp[0].minor.yy0.len = unescapen((char*)yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len);
    yylhsminor.yy0 = yymsp[0].minor.yy0;
 }
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 48: /* modifierlist ::= modifier OR term */
{
    yylhsminor.yy103 = NewVector(char *, 2);
    char *s = rm_strndup(yymsp[-2].minor.yy0.s, yymsp[-2].minor.yy0.len);
    Vector_Push(yylhsminor.yy103, s);
    s = rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len);
    Vector_Push(yylhsminor.yy103, s);
}
  yymsp[-2].minor.yy103 = yylhsminor.yy103;
        break;
      case 49: /* modifierlist ::= modifierlist OR term */
{
    char *s = rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len);
    Vector_Push(yymsp[-2].minor.yy103, s);
    yylhsminor.yy103 = yymsp[-2].minor.yy103;
}
  yymsp[-2].minor.yy103 = yylhsminor.yy103;
        break;
      case 50: /* expr ::= modifier COLON LB tag_list RB */
{
    if (!yymsp[-1].minor.yy111) {
        yylhsminor.yy111 = NULL;
    } else {
      // Tag field names must be case sensitive, we can't do rm_strdupcase
        char *s = rm_strndup(yymsp[-4].minor.yy0.s, yymsp[-4].minor.yy0.len);
        size_t slen = unescapen((char*)s, yymsp[-4].minor.yy0.len);

        yylhsminor.yy111 = NewTagNode(s, slen);
        QueryNode_AddChildren(yylhsminor.yy111, yymsp[-1].minor.yy111->children, QueryNode_NumChildren(yymsp[-1].minor.yy111));

        // Set the children count on yymsp[-1].minor.yy111 to 0 so they won't get recursively free'd
        QueryNode_ClearChildren(yymsp[-1].minor.yy111, 0);
        QueryNode_Free(yymsp[-1].minor.yy111);
    }
}
  yymsp[-4].minor.yy111 = yylhsminor.yy111;
        break;
      case 51: /* tag_list ::= param_term */
{
  yylhsminor.yy111 = NewPhraseNode(0);
  if (yymsp[0].minor.yy0.type == QT_TERM)
    yymsp[0].minor.yy0.type = QT_TERM_CASE;
  else if (yymsp[0].minor.yy0.type == QT_PARAM_TERM)
    yymsp[0].minor.yy0.type = QT_PARAM_TERM_CASE;
  QueryNode_AddChild(yylhsminor.yy111, NewTokenNode_WithParams(ctx, &yymsp[0].minor.yy0));
}
  yymsp[0].minor.yy111 = yylhsminor.yy111;
        break;
      case 52: /* tag_list ::= STOPWORD */
{
    yylhsminor.yy111 = NewPhraseNode(0);
    QueryNode_AddChild(yylhsminor.yy111, NewTokenNode(ctx, rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len), -1));
}
  yymsp[0].minor.yy111 = yylhsminor.yy111;
        break;
      case 53: /* tag_list ::= prefix */
      case 54: /* tag_list ::= termlist */ yytestcase(yyruleno==54);
{
    yylhsminor.yy111 = NewPhraseNode(0);
    QueryNode_AddChild(yylhsminor.yy111, yymsp[0].minor.yy111);
}
  yymsp[0].minor.yy111 = yylhsminor.yy111;
        break;
      case 55: /* tag_list ::= tag_list OR param_term */
{
  if (yymsp[0].minor.yy0.type == QT_TERM)
    yymsp[0].minor.yy0.type = QT_TERM_CASE;
  else if (yymsp[0].minor.yy0.type == QT_PARAM_TERM)
    yymsp[0].minor.yy0.type = QT_PARAM_TERM_CASE;
  QueryNode_AddChild(yymsp[-2].minor.yy111, NewTokenNode_WithParams(ctx, &yymsp[0].minor.yy0));
  yylhsminor.yy111 = yymsp[-2].minor.yy111;
}
  yymsp[-2].minor.yy111 = yylhsminor.yy111;
        break;
      case 56: /* tag_list ::= tag_list OR STOPWORD */
{
    QueryNode_AddChild(yymsp[-2].minor.yy111, NewTokenNode(ctx, rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len), -1));
    yylhsminor.yy111 = yymsp[-2].minor.yy111;
}
  yymsp[-2].minor.yy111 = yylhsminor.yy111;
        break;
      case 57: /* tag_list ::= tag_list OR prefix */
      case 58: /* tag_list ::= tag_list OR termlist */ yytestcase(yyruleno==58);
{
    QueryNode_AddChild(yymsp[-2].minor.yy111, yymsp[0].minor.yy111);
    yylhsminor.yy111 = yymsp[-2].minor.yy111;
}
  yymsp[-2].minor.yy111 = yylhsminor.yy111;
        break;
      case 59: /* expr ::= modifier COLON numeric_range */
{
  if (yymsp[0].minor.yy22) {
    // we keep the capitalization as is
    yymsp[0].minor.yy22->nf->fieldName = rm_strndup(yymsp[-2].minor.yy0.s, yymsp[-2].minor.yy0.len);
    yylhsminor.yy111 = NewNumericNode(yymsp[0].minor.yy22);
  } else {
    yylhsminor.yy111 = NewQueryNode(QN_NULL);
  }
}
  yymsp[-2].minor.yy111 = yylhsminor.yy111;
        break;
      case 60: /* numeric_range ::= LSQB param_any param_any RSQB */
{
  // Update token type to be more specific if possible
  // and detect syntax errors
  QueryToken *badToken = NULL;
  if (yymsp[-2].minor.yy0.type == QT_PARAM_ANY)
    yymsp[-2].minor.yy0.type = QT_PARAM_NUMERIC_MIN_RANGE;
  else if (yymsp[-2].minor.yy0.type != QT_NUMERIC)
    badToken = &yymsp[-2].minor.yy0;
  if (yymsp[-1].minor.yy0.type == QT_PARAM_ANY)
    yymsp[-1].minor.yy0.type = QT_PARAM_NUMERIC_MAX_RANGE;
  else if (!badToken && yymsp[-1].minor.yy0.type != QT_NUMERIC)
    badToken = &yymsp[-1].minor.yy0;

  if (!badToken) {
    yymsp[-3].minor.yy22 = NewNumericFilterQueryParam_WithParams(ctx, &yymsp[-2].minor.yy0, &yymsp[-1].minor.yy0, yymsp[-2].minor.yy0.inclusive, yymsp[-1].minor.yy0.inclusive);
  } else {
    reportSyntaxError(ctx->status, badToken, "Expecting numeric or parameter");
    yymsp[-3].minor.yy22 = NULL;
  }
}
        break;
      case 61: /* expr ::= modifier COLON geo_filter */
{
  if (yymsp[0].minor.yy22) {
    // we keep the capitalization as is
    yymsp[0].minor.yy22->gf->property = rm_strndup(yymsp[-2].minor.yy0.s, yymsp[-2].minor.yy0.len);
    yylhsminor.yy111 = NewGeofilterNode(yymsp[0].minor.yy22);
  } else {
    yylhsminor.yy111 = NewQueryNode(QN_NULL);
  }
}
  yymsp[-2].minor.yy111 = yylhsminor.yy111;
        break;
      case 62: /* geo_filter ::= LSQB param_any param_any param_any param_any RSQB */
{
  // Update token type to be more specific if possible
  // and detect syntax errors
  QueryToken *badToken = NULL;

  if (yymsp[-4].minor.yy0.type == QT_PARAM_ANY)
    yymsp[-4].minor.yy0.type = QT_PARAM_GEO_COORD;
  else if (yymsp[-4].minor.yy0.type != QT_NUMERIC)
    badToken = &yymsp[-4].minor.yy0;
  if (yymsp[-3].minor.yy0.type == QT_PARAM_ANY)
    yymsp[-3].minor.yy0.type = QT_PARAM_GEO_COORD;
  else if (!badToken && yymsp[-3].minor.yy0.type != QT_NUMERIC)
    badToken = &yymsp[-3].minor.yy0;
  if (yymsp[-2].minor.yy0.type == QT_PARAM_ANY)
    yymsp[-2].minor.yy0.type = QT_PARAM_NUMERIC;
  else if (!badToken && yymsp[-2].minor.yy0.type != QT_NUMERIC)
    badToken = &yymsp[-2].minor.yy0;
  if (yymsp[-1].minor.yy0.type == QT_PARAM_ANY)
    yymsp[-1].minor.yy0.type = QT_PARAM_GEO_UNIT;
  else if (!badToken && yymsp[-1].minor.yy0.type != QT_TERM)
    badToken = &yymsp[-1].minor.yy0;

  if (!badToken) {
    yymsp[-5].minor.yy22 = NewGeoFilterQueryParam_WithParams(ctx, &yymsp[-4].minor.yy0, &yymsp[-3].minor.yy0, &yymsp[-2].minor.yy0, &yymsp[-1].minor.yy0);
  } else {
    reportSyntaxError(ctx->status, badToken, "Syntax error");
    yymsp[-5].minor.yy22 = NULL;
  }
}
        break;
      case 63: /* query ::= expr ARROW LSQB vector_query RSQB */
      case 64: /* query ::= text_expr ARROW LSQB vector_query RSQB */ yytestcase(yyruleno==64);
{ // main parse, hybrid query as entire query case.
  setup_trace(ctx);
  switch (yymsp[-1].minor.yy111->vn.vq->type) {
    case VECSIM_QT_KNN:
      yymsp[-1].minor.yy111->vn.vq->knn.order = BY_SCORE;
      break;
  }
  ctx->root = yymsp[-1].minor.yy111;
  if (yymsp[-4].minor.yy111) {
    QueryNode_AddChild(yymsp[-1].minor.yy111, yymsp[-4].minor.yy111);
  }
}
        break;
      case 65: /* query ::= star ARROW LSQB vector_query RSQB */
{  yy_destructor(yypParser,50,&yymsp[-4].minor);
{ // main parse, simple vecsim search as entire query case.
  setup_trace(ctx);
  switch (yymsp[-1].minor.yy111->vn.vq->type) {
    case VECSIM_QT_KNN:
      yymsp[-1].minor.yy111->vn.vq->knn.order = BY_SCORE;
      break;
  }
  ctx->root = yymsp[-1].minor.yy111;
}
}
        break;
      case 66: /* vector_query ::= vector_command vector_attribute_list vector_score_field */
{
  if (yymsp[-2].minor.yy111->vn.vq->scoreField) {
    rm_free(yymsp[-2].minor.yy111->vn.vq->scoreField);
    yymsp[-2].minor.yy111->vn.vq->scoreField = NULL;
  }
  yymsp[-2].minor.yy111->params = array_grow(yymsp[-2].minor.yy111->params, 1);
  memset(&array_tail(yymsp[-2].minor.yy111->params), 0, sizeof(*yymsp[-2].minor.yy111->params));
  QueryNode_SetParam(ctx, &(array_tail(yymsp[-2].minor.yy111->params)), &(yymsp[-2].minor.yy111->vn.vq->scoreField), NULL, &yymsp[0].minor.yy0);
  yymsp[-2].minor.yy111->vn.vq->params = yymsp[-1].minor.yy102;
  yylhsminor.yy111 = yymsp[-2].minor.yy111;
}
  yymsp[-2].minor.yy111 = yylhsminor.yy111;
        break;
      case 67: /* vector_query ::= vector_command vector_score_field */
{
  if (yymsp[-1].minor.yy111->vn.vq->scoreField) {
    rm_free(yymsp[-1].minor.yy111->vn.vq->scoreField);
    yymsp[-1].minor.yy111->vn.vq->scoreField = NULL;
  }
  yymsp[-1].minor.yy111->params = array_grow(yymsp[-1].minor.yy111->params, 1);
  memset(&array_tail(yymsp[-1].minor.yy111->params), 0, sizeof(*yymsp[-1].minor.yy111->params));
  QueryNode_SetParam(ctx, &(array_tail(yymsp[-1].minor.yy111->params)), &(yymsp[-1].minor.yy111->vn.vq->scoreField), NULL, &yymsp[0].minor.yy0);
  yylhsminor.yy111 = yymsp[-1].minor.yy111;
}
  yymsp[-1].minor.yy111 = yylhsminor.yy111;
        break;
      case 68: /* vector_query ::= vector_command vector_attribute_list */
{
  yymsp[-1].minor.yy111->vn.vq->params = yymsp[0].minor.yy102;
  yylhsminor.yy111 = yymsp[-1].minor.yy111;
}
  yymsp[-1].minor.yy111 = yylhsminor.yy111;
        break;
      case 70: /* vector_score_field ::= as param_term */
{  yy_destructor(yypParser,56,&yymsp[-1].minor);
{
  yymsp[-1].minor.yy0 = yymsp[0].minor.yy0;
}
}
        break;
      case 71: /* vector_score_field ::= as STOPWORD */
{  yy_destructor(yypParser,56,&yymsp[-1].minor);
{
  yymsp[-1].minor.yy0 = yymsp[0].minor.yy0;
  yymsp[-1].minor.yy0.type = QT_TERM;
}
}
        break;
      case 72: /* vector_command ::= TERM param_size modifier ATTRIBUTE */
{
  if (!strncasecmp("KNN", yymsp[-3].minor.yy0.s, yymsp[-3].minor.yy0.len)) {
    yymsp[0].minor.yy0.type = QT_PARAM_VEC;
    yylhsminor.yy111 = NewVectorNode_WithParams(ctx, VECSIM_QT_KNN, &yymsp[-2].minor.yy0, &yymsp[0].minor.yy0);
    yylhsminor.yy111->vn.vq->property = rm_strndup(yymsp[-1].minor.yy0.s, yymsp[-1].minor.yy0.len);
    RedisModule_Assert(-1 != (rm_asprintf(&yylhsminor.yy111->vn.vq->scoreField, "__%.*s_score", yymsp[-1].minor.yy0.len, yymsp[-1].minor.yy0.s)));
  } else {
    reportSyntaxError(ctx->status, &yymsp[-3].minor.yy0, "Syntax error: Expecting Vector Similarity command");
    yylhsminor.yy111 = NULL;
  }
}
  yymsp[-3].minor.yy111 = yylhsminor.yy111;
        break;
      case 73: /* vector_attribute ::= TERM param_term */
{
  const char *value = rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len);
  const char *name = rm_strndup(yymsp[-1].minor.yy0.s, yymsp[-1].minor.yy0.len);
  yylhsminor.yy9.param = (VecSimRawParam){ .name = name, .nameLen = yymsp[-1].minor.yy0.len, .value = value, .valLen = yymsp[0].minor.yy0.len };
  if (yymsp[0].minor.yy0.type == QT_PARAM_TERM) {
    yylhsminor.yy9.needResolve = true;
  }
  else { // if yymsp[0].minor.yy0.type == QT_TERM
    yylhsminor.yy9.needResolve = false;
  }
}
  yymsp[-1].minor.yy9 = yylhsminor.yy9;
        break;
      case 74: /* vector_attribute_list ::= vector_attribute_list vector_attribute */
{
  yylhsminor.yy102.params = array_append(yymsp[-1].minor.yy102.params, yymsp[0].minor.yy9.param);
  yylhsminor.yy102.needResolve = array_append(yymsp[-1].minor.yy102.needResolve, yymsp[0].minor.yy9.needResolve);
}
  yymsp[-1].minor.yy102 = yylhsminor.yy102;
        break;
      case 75: /* vector_attribute_list ::= vector_attribute */
{
  yylhsminor.yy102.params = array_new(VecSimRawParam, 1);
  yylhsminor.yy102.needResolve = array_new(bool, 1);
  yylhsminor.yy102.params = array_append(yylhsminor.yy102.params, yymsp[0].minor.yy9.param);
  yylhsminor.yy102.needResolve = array_append(yylhsminor.yy102.needResolve, yymsp[0].minor.yy9.needResolve);
}
  yymsp[0].minor.yy102 = yylhsminor.yy102;
        break;
      case 76: /* num ::= SIZE */
      case 77: /* num ::= NUMBER */ yytestcase(yyruleno==77);
{
  yylhsminor.yy79.num = yymsp[0].minor.yy0.numval;
  yylhsminor.yy79.inclusive = 1;
}
  yymsp[0].minor.yy79 = yylhsminor.yy79;
        break;
      case 78: /* num ::= LP num */
{
  yymsp[-1].minor.yy79=yymsp[0].minor.yy79;
  yymsp[-1].minor.yy79.inclusive = 0;
}
        break;
      case 79: /* num ::= MINUS num */
{
  yymsp[0].minor.yy79.num = -yymsp[0].minor.yy79.num;
  yymsp[-1].minor.yy79 = yymsp[0].minor.yy79;
}
        break;
      case 80: /* term ::= TERM */
      case 81: /* term ::= NUMBER */ yytestcase(yyruleno==81);
      case 82: /* term ::= SIZE */ yytestcase(yyruleno==82);
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 83: /* param_term ::= TERM */
      case 84: /* param_term ::= NUMBER */ yytestcase(yyruleno==84);
      case 85: /* param_term ::= SIZE */ yytestcase(yyruleno==85);
      case 91: /* param_any ::= TERM */ yytestcase(yyruleno==91);
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
  yylhsminor.yy0.type = QT_TERM;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 86: /* param_term ::= ATTRIBUTE */
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
  yylhsminor.yy0.type = QT_PARAM_TERM;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 87: /* param_size ::= SIZE */
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
  yylhsminor.yy0.type = QT_SIZE;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 88: /* param_size ::= ATTRIBUTE */
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
  yylhsminor.yy0.type = QT_PARAM_SIZE;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 89: /* param_any ::= ATTRIBUTE */
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
  yylhsminor.yy0.type = QT_PARAM_ANY;
  yylhsminor.yy0.inclusive = 1;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 90: /* param_any ::= LP ATTRIBUTE */
{
  yymsp[-1].minor.yy0 = yymsp[0].minor.yy0;
  yymsp[-1].minor.yy0.type = QT_PARAM_ANY;
  yymsp[-1].minor.yy0.inclusive = 0; // Could be relevant if type is refined
}
        break;
      case 92: /* param_any ::= num */
{
  yylhsminor.yy0.numval = yymsp[0].minor.yy79.num;
  yylhsminor.yy0.inclusive = yymsp[0].minor.yy79.inclusive;
  yylhsminor.yy0.type = QT_NUMERIC;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 94: /* star ::= LP star RP */
{
}
  yy_destructor(yypParser,50,&yymsp[-1].minor);
        break;
      default:
      /* (93) star ::= STAR */ yytestcase(yyruleno==93);
      /* (95) as ::= AS_T */ yytestcase(yyruleno==95);
      /* (96) as ::= AS_S */ yytestcase(yyruleno==96);
        break;
/********** End reduce actions ************************************************/
  };
  assert( yyruleno<sizeof(yyRuleInfoLhs)/sizeof(yyRuleInfoLhs[0]) );
  yygoto = yyRuleInfoLhs[yyruleno];
  yysize = yyRuleInfoNRhs[yyruleno];
  yyact = yy_find_reduce_action(yymsp[yysize].stateno,(YYCODETYPE)yygoto);

  /* There are no SHIFTREDUCE actions on nonterminals because the table
  ** generator has simplified them to pure REDUCE actions. */
  assert( !(yyact>YY_MAX_SHIFT && yyact<=YY_MAX_SHIFTREDUCE) );

  /* It is not possible for a REDUCE to be followed by an error */
  assert( yyact!=YY_ERROR_ACTION );

  yymsp += yysize+1;
  yypParser->yytos = yymsp;
  yymsp->stateno = (YYACTIONTYPE)yyact;
  yymsp->major = (YYCODETYPE)yygoto;
  yyTraceShift(yypParser, yyact, "... then shift");
  return yyact;
}

/*
** The following code executes when the parse fails
*/
#ifndef YYNOERRORRECOVERY
static void yy_parse_failed(
  yyParser *yypParser           /* The parser */
){
  RSQueryParser_v2_ARG_FETCH
  RSQueryParser_v2_CTX_FETCH
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sFail!\n",yyTracePrompt);
  }
#endif
  while( yypParser->yytos>yypParser->yystack ) yy_pop_parser_stack(yypParser);
  /* Here code is inserted which will be executed whenever the
  ** parser fails */
/************ Begin %parse_failure code ***************************************/
/************ End %parse_failure code *****************************************/
  RSQueryParser_v2_ARG_STORE /* Suppress warning about unused %extra_argument variable */
  RSQueryParser_v2_CTX_STORE
}
#endif /* YYNOERRORRECOVERY */

/*
** The following code executes when a syntax error first occurs.
*/
static void yy_syntax_error(
  yyParser *yypParser,           /* The parser */
  int yymajor,                   /* The major type of the error token */
  RSQueryParser_v2_TOKENTYPE yyminor         /* The minor type of the error token */
){
  RSQueryParser_v2_ARG_FETCH
  RSQueryParser_v2_CTX_FETCH
#define TOKEN yyminor
/************ Begin %syntax_error code ****************************************/

  QueryError_SetErrorFmt(ctx->status, QUERY_ESYNTAX,
    "Syntax error at offset %d near %.*s",
    TOKEN.pos, TOKEN.len, TOKEN.s);
/************ End %syntax_error code ******************************************/
  RSQueryParser_v2_ARG_STORE /* Suppress warning about unused %extra_argument variable */
  RSQueryParser_v2_CTX_STORE
}

/*
** The following is executed when the parser accepts
*/
static void yy_accept(
  yyParser *yypParser           /* The parser */
){
  RSQueryParser_v2_ARG_FETCH
  RSQueryParser_v2_CTX_FETCH
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sAccept!\n",yyTracePrompt);
  }
#endif
#ifndef YYNOERRORRECOVERY
  yypParser->yyerrcnt = -1;
#endif
  assert( yypParser->yytos==yypParser->yystack );
  /* Here code is inserted which will be executed whenever the
  ** parser accepts */
/*********** Begin %parse_accept code *****************************************/
/*********** End %parse_accept code *******************************************/
  RSQueryParser_v2_ARG_STORE /* Suppress warning about unused %extra_argument variable */
  RSQueryParser_v2_CTX_STORE
}

/* The main parser program.
** The first argument is a pointer to a structure obtained from
** "RSQueryParser_v2_Alloc" which describes the current state of the parser.
** The second argument is the major token number.  The third is
** the minor token.  The fourth optional argument is whatever the
** user wants (and specified in the grammar) and is available for
** use by the action routines.
**
** Inputs:
** <ul>
** <li> A pointer to the parser (an opaque structure.)
** <li> The major token number.
** <li> The minor token number.
** <li> An option argument of a grammar-specified type.
** </ul>
**
** Outputs:
** None.
*/
void RSQueryParser_v2_(
  void *yyp,                   /* The parser */
  int yymajor,                 /* The major token code number */
  RSQueryParser_v2_TOKENTYPE yyminor       /* The value for the token */
  RSQueryParser_v2_ARG_PDECL               /* Optional %extra_argument parameter */
){
  YYMINORTYPE yyminorunion;
  YYACTIONTYPE yyact;   /* The parser action. */
#if !defined(YYERRORSYMBOL) && !defined(YYNOERRORRECOVERY)
  int yyendofinput;     /* True if we are at the end of input */
#endif
#ifdef YYERRORSYMBOL
  int yyerrorhit = 0;   /* True if yymajor has invoked an error */
#endif
  yyParser *yypParser = (yyParser*)yyp;  /* The parser */
  RSQueryParser_v2_CTX_FETCH
  RSQueryParser_v2_ARG_STORE

  assert( yypParser->yytos!=0 );
#if !defined(YYERRORSYMBOL) && !defined(YYNOERRORRECOVERY)
  yyendofinput = (yymajor==0);
#endif

  yyact = yypParser->yytos->stateno;
#ifndef NDEBUG
  if( yyTraceFILE ){
    if( yyact < YY_MIN_REDUCE ){
      fprintf(yyTraceFILE,"%sInput '%s' in state %d\n",
              yyTracePrompt,yyTokenName[yymajor],yyact);
    }else{
      fprintf(yyTraceFILE,"%sInput '%s' with pending reduce %d\n",
              yyTracePrompt,yyTokenName[yymajor],yyact-YY_MIN_REDUCE);
    }
  }
#endif

  while(1){ /* Exit by "break" */
    assert( yypParser->yytos>=yypParser->yystack );
    assert( yyact==yypParser->yytos->stateno );
    yyact = yy_find_shift_action((YYCODETYPE)yymajor,yyact);
    if( yyact >= YY_MIN_REDUCE ){
      unsigned int yyruleno = yyact - YY_MIN_REDUCE; /* Reduce by this rule */
#ifndef NDEBUG
      assert( yyruleno<(int)(sizeof(yyRuleName)/sizeof(yyRuleName[0])) );
      if( yyTraceFILE ){
        int yysize = yyRuleInfoNRhs[yyruleno];
        if( yysize ){
          fprintf(yyTraceFILE, "%sReduce %d [%s]%s, pop back to state %d.\n",
            yyTracePrompt,
            yyruleno, yyRuleName[yyruleno],
            yyruleno<YYNRULE_WITH_ACTION ? "" : " without external action",
            yypParser->yytos[yysize].stateno);
        }else{
          fprintf(yyTraceFILE, "%sReduce %d [%s]%s.\n",
            yyTracePrompt, yyruleno, yyRuleName[yyruleno],
            yyruleno<YYNRULE_WITH_ACTION ? "" : " without external action");
        }
      }
#endif /* NDEBUG */

      /* Check that the stack is large enough to grow by a single entry
      ** if the RHS of the rule is empty.  This ensures that there is room
      ** enough on the stack to push the LHS value */
      if( yyRuleInfoNRhs[yyruleno]==0 ){
#ifdef YYTRACKMAXSTACKDEPTH
        if( (int)(yypParser->yytos - yypParser->yystack)>yypParser->yyhwm ){
          yypParser->yyhwm++;
          assert( yypParser->yyhwm ==
                  (int)(yypParser->yytos - yypParser->yystack));
        }
#endif
#if YYSTACKDEPTH>0 
        if( yypParser->yytos>=yypParser->yystackEnd ){
          yyStackOverflow(yypParser);
          break;
        }
#else
        if( yypParser->yytos>=&yypParser->yystack[yypParser->yystksz-1] ){
          if( yyGrowStack(yypParser) ){
            yyStackOverflow(yypParser);
            break;
          }
        }
#endif
      }
      yyact = yy_reduce(yypParser,yyruleno,yymajor,yyminor RSQueryParser_v2_CTX_PARAM);
    }else if( yyact <= YY_MAX_SHIFTREDUCE ){
      yy_shift(yypParser,yyact,(YYCODETYPE)yymajor,yyminor);
#ifndef YYNOERRORRECOVERY
      yypParser->yyerrcnt--;
#endif
      break;
    }else if( yyact==YY_ACCEPT_ACTION ){
      yypParser->yytos--;
      yy_accept(yypParser);
      return;
    }else{
      assert( yyact == YY_ERROR_ACTION );
      yyminorunion.yy0 = yyminor;
#ifdef YYERRORSYMBOL
      int yymx;
#endif
#ifndef NDEBUG
      if( yyTraceFILE ){
        fprintf(yyTraceFILE,"%sSyntax Error!\n",yyTracePrompt);
      }
#endif
#ifdef YYERRORSYMBOL
      /* A syntax error has occurred.
      ** The response to an error depends upon whether or not the
      ** grammar defines an error token "ERROR".  
      **
      ** This is what we do if the grammar does define ERROR:
      **
      **  * Call the %syntax_error function.
      **
      **  * Begin popping the stack until we enter a state where
      **    it is legal to shift the error symbol, then shift
      **    the error symbol.
      **
      **  * Set the error count to three.
      **
      **  * Begin accepting and shifting new tokens.  No new error
      **    processing will occur until three tokens have been
      **    shifted successfully.
      **
      */
      if( yypParser->yyerrcnt<0 ){
        yy_syntax_error(yypParser,yymajor,yyminor);
      }
      yymx = yypParser->yytos->major;
      if( yymx==YYERRORSYMBOL || yyerrorhit ){
#ifndef NDEBUG
        if( yyTraceFILE ){
          fprintf(yyTraceFILE,"%sDiscard input token %s\n",
             yyTracePrompt,yyTokenName[yymajor]);
        }
#endif
        yy_destructor(yypParser, (YYCODETYPE)yymajor, &yyminorunion);
        yymajor = YYNOCODE;
      }else{
        while( yypParser->yytos > yypParser->yystack ){
          yyact = yy_find_reduce_action(yypParser->yytos->stateno,
                                        YYERRORSYMBOL);
          if( yyact<=YY_MAX_SHIFTREDUCE ) break;
          yy_pop_parser_stack(yypParser);
        }
        if( yypParser->yytos <= yypParser->yystack || yymajor==0 ){
          yy_destructor(yypParser,(YYCODETYPE)yymajor,&yyminorunion);
          yy_parse_failed(yypParser);
#ifndef YYNOERRORRECOVERY
          yypParser->yyerrcnt = -1;
#endif
          yymajor = YYNOCODE;
        }else if( yymx!=YYERRORSYMBOL ){
          yy_shift(yypParser,yyact,YYERRORSYMBOL,yyminor);
        }
      }
      yypParser->yyerrcnt = 3;
      yyerrorhit = 1;
      if( yymajor==YYNOCODE ) break;
      yyact = yypParser->yytos->stateno;
#elif defined(YYNOERRORRECOVERY)
      /* If the YYNOERRORRECOVERY macro is defined, then do not attempt to
      ** do any kind of error recovery.  Instead, simply invoke the syntax
      ** error routine and continue going as if nothing had happened.
      **
      ** Applications can set this macro (for example inside %include) if
      ** they intend to abandon the parse upon the first syntax error seen.
      */
      yy_syntax_error(yypParser,yymajor, yyminor);
      yy_destructor(yypParser,(YYCODETYPE)yymajor,&yyminorunion);
      break;
#else  /* YYERRORSYMBOL is not defined */
      /* This is what we do if the grammar does not define ERROR:
      **
      **  * Report an error message, and throw away the input token.
      **
      **  * If the input token is $, then fail the parse.
      **
      ** As before, subsequent error messages are suppressed until
      ** three input tokens have been successfully shifted.
      */
      if( yypParser->yyerrcnt<=0 ){
        yy_syntax_error(yypParser,yymajor, yyminor);
      }
      yypParser->yyerrcnt = 3;
      yy_destructor(yypParser,(YYCODETYPE)yymajor,&yyminorunion);
      if( yyendofinput ){
        yy_parse_failed(yypParser);
#ifndef YYNOERRORRECOVERY
        yypParser->yyerrcnt = -1;
#endif
      }
      break;
#endif
    }
  }
#ifndef NDEBUG
  if( yyTraceFILE ){
    yyStackEntry *i;
    char cDiv = '[';
    fprintf(yyTraceFILE,"%sReturn. Stack=",yyTracePrompt);
    for(i=&yypParser->yystack[1]; i<=yypParser->yytos; i++){
      fprintf(yyTraceFILE,"%c%s", cDiv, yyTokenName[i->major]);
      cDiv = ' ';
    }
    fprintf(yyTraceFILE,"]\n");
  }
#endif
  return;
}

/*
** Return the fallback token corresponding to canonical token iToken, or
** 0 if iToken has no fallback.
*/
int RSQueryParser_v2_Fallback(int iToken){
#ifdef YYFALLBACK
  assert( iToken<(int)(sizeof(yyFallback)/sizeof(yyFallback[0])) );
  return yyFallback[iToken];
#else
  (void)iToken;
  return 0;
#endif
}
